@echo off
cls

SET SET_JDKHOME=off
SET SET_MAVENHOME=off
SET SET_INSTALLDIR=off
SET SET_RELEASE=off

SET SET_BUILD_COMPILER=off
SET SET_BUILD_OPTIMIZE=off
SET SET_BUILD_DEBUG=off
SET SET_JOPT_JAR=off

SET MAVENHOME_CALL=no

rem *********************************************
rem *            Init value
rem *********************************************

if exist build.properties goto init
call .\util\make\readregistry.exe
if errorlevel==1 goto end
for /F %%a in (instdir.txt) do SET JDKHOME=%%a
del instdir.txt>nul

:start
if %1.==. goto default
if %1==-help goto help
if %1==-jdkhome goto jdkhome
if %1==-mavenhome goto mavenhome
if %1==-release goto release
if %1==-prefix goto instdir

if %1==-compiler goto compiler
if %1==-optimize goto optimize
if %1==-debug goto debug
if %1==-jopt goto jopt
goto error

:default
rem *********************************************
rem *            Default value
rem *********************************************
SET RELEASE=1
SET MAVENHOME=
SET INSTALLDIR=
SET BUILD_COMPILER=jikes
SET BUILD_OPTIMIZE=on
SET BUILD_DEBUG=off
SET JOPT_JAR=


rem
rem Set value JDKHOME by Java Home directory with value from registry file or 
rem if this key not exist reading enviroment variable JAVA_HOME else generate
rem warning dialog
rem
call .\util\make\readregistry.exe
if errorlevel==1 goto end
for /F %%a in (instdir.txt) do SET JDKHOME=%%a
del instdir.txt>nul
goto make

:init
find "jdk.dir" < build.properties > javadir.txt
for /F "tokens=1,2* delims==" %%i in (javadir.txt) do SET JDKHOME=%%j
del javadir.txt>nul
if "X%JDKHOME%"=="X" goto initjava
goto initmaven

:initjava
call .\util\make\readregistry.exe
if errorlevel==1 goto end
for /F %%a in (instdir.txt) do SET JDKHOME=%%a
del instdir.txt>nul
goto initmaven

:initmaven
find "maven.path" < build.properties > mavendir.txt
for /F "tokens=1,2* delims==" %%i in (mavendir.txt) do SET MAVENHOME=%%j
del mavendir.txt>nul
goto initinstalldir

:initinstalldir
find "prefix" < build.properties > output.txt
for /F "tokens=1,2* delims==" %%i in (output.txt) do SET INSTALLDIR=%%j
del output.txt>nul
goto initrelease

:initrelease
find "release" < build.properties > release.txt
for /F "tokens=1,2* delims==" %%i in (release.txt) do SET RELEASE=%%j
del release.txt>nul
goto initcompiler

:initcompiler
find "build.compiler" < build.properties > compiler.txt
for /F "tokens=1,2* delims==" %%i in (compiler.txt) do SET BUILD_COMPILER=%%j
del compiler.txt>nul
goto initoptimize

:initoptimize
find "build.optimize" < build.properties > optimize.txt
for /F "tokens=1,2* delims==" %%i in (optimize.txt) do SET BUILD_OPTIMIZE=%%j
del optimize.txt>nul
goto initdebug

:initdebug
find "build.debug" < build.properties > debug.txt
for /F "tokens=1,2* delims==" %%i in (debug.txt) do SET BUILD_DEBUG=%%j
del debug.txt>nul
goto initjopt

:initjopt
find "jopt.jar" < build.properties > jopt.txt
for /F "tokens=1,2* delims==" %%i in (jopt.txt) do SET JOPT_JAR=%%j
del jopt.txt>nul
goto start


:make
if exist build.properties del build.properties
echo jdk.dir=%JDKHOME%>build.properties
echo maven.path=%MAVENHOME%>>build.properties
echo prefix=%INSTALLDIR%>>build.properties
echo release=^%RELEASE%>>build.properties

echo build.compiler=%BUILD_COMPILER%>>build.properties
echo build.optimize=%BUILD_OPTIMIZE%>>build.properties
echo build.debug=%BUILD_DEBUG%>>build.properties
echo jopt.jar=%JOPT_JAR%>>build.properties

set OLDCLASSPATH=%CLASSPATH%
set CLASSPATH=%CLASSPATH%;.\..\maven\lib\ant-1.5.1.jar
"%JDKHOME%\bin\java" org.apache.tools.ant.Main -DSYSTEMROOT=%SYSTEMROOT% winconfig

if %MAVENHOME_CALL%==no goto callmavenhomeconfig

goto end 

:error
echo.
echo Invalid options using with configure.bat
echo.

:help
echo.
echo Parameters value for using with configure.bat :
echo.
echo configure       - Make build.properties file with default values
echo.
echo configure -help - Display this screen
echo.
echo configure [-release release_number] [-jdkhome jdk_home_dir] [-mavenhome maven_home] [-prefix installdir] 
echo.		   [-compiler compiler_name] [-optimize optimize_on_off] [-debug debug_on_off] [-jopt jopt_location] 
echo.
echo Examples :
echo.
echo configure -release 1 -jdkhome C:/j2sdk1.4.1 -prefix D:/Octopus -mavenhome D:/maven
echo.
goto end 

:jdkhome
if %SET_JDKHOME%==on goto error
shift
if "X%1"=="X" goto error
SET JDKHOME=%1
SET SET_JDKHOME=on
shift
if "X%1"=="X" goto make
if %1==-help goto error
if %1==-jdkhome goto error
if %1==-mavenhome goto mavenhome
if %1==-prefix goto instdir
if %1==-release goto release
goto error

:mavenhome
SET MAVENHOME_CALL=yes
if %SET_MAVENHOME%==on goto error
shift
if "X%1"=="X" goto error
SET MAVENHOME=%1
SET SET_MAVENHOME=on
shift
if "X%1"=="X" goto make
if %1==-help goto error
if %1==-jdkhome goto jdkhome
if %1==-mavenhome goto error
if %1==-prefix goto instdir
if %1==-release goto release
goto error

:release
if %SET_RELEASE%==on goto error
shift
if "X%1"=="X" goto error
SET RELEASE=%1
SET SET_RELEASE=on
shift
if "X%1"=="X" goto make
if %1==-help goto error
if %1==-jdkhome goto jdkhome
if %1==-mavenhome goto mavenhome
if %1==-prefix goto instdir
if %1==-release goto error
goto error

:instdir
if %SET_INSTALLDIR%==on goto error
shift
if "X%1"=="X" goto error
SET INSTALLDIR=%1
SET SET_INSTALLDIR=on
shift
if "X%1"=="X" goto make
if %1==-help goto error
if %1==-jdkhome goto jdkhome
if %1==-mavenhome goto mavenhome
if %1==-prefix goto error
if %1==-release goto release
goto error

:compiler
if %SET_BUILD_COMPILER%==on goto error
shift
if "X%1"=="X" goto error
SET BUILD_COMPILER=%1
SET SET_BUILD_COMPILER=on
shift
if "X%1"=="X" goto make
if %1==-help goto error
if %1==-jdkhome goto jdkhome
if %1==-mavenhome goto mavenhome
if %1==-prefix goto error
if %1==-release goto release
if %1==-optimize goto optimize
if %1==-debug goto debug
if %1==-jopt goto jopt
goto error

:optimize
if %SET_BUILD_OPTIMIZE%==on goto error
shift
if "X%1"=="X" goto error
SET BUILD_OPTIMIZE=%1
SET SET_BUILD_OPTIMIZE=on
shift
if "X%1"=="X" goto make
if %1==-help goto error
if %1==-jdkhome goto jdkhome
if %1==-mavenhome goto mavenhome
if %1==-prefix goto error
if %1==-release goto release
if %1==-compiler goto compiler
if %1==-debug goto debug
if %1==-jopt goto jopt
goto error

:debug
if %SET_BUILD_DEBUG%==on goto error
shift
if "X%1"=="X" goto error
SET BUILD_DEBUG=%1
SET SET_BUILD_DEBUG=on
shift
if "X%1"=="X" goto make
if %1==-help goto error
if %1==-jdkhome goto jdkhome
if %1==-mavenhome goto mavenhome
if %1==-prefix goto error
if %1==-release goto release
if %1==-compiler goto compiler
if %1==-optimize goto optimize
if %1==-jopt goto jopt
goto error

:jopt
if %SET_JOPT_JAR%==on goto error
shift
if "X%1"=="X" goto error
SET JOPT_JAR=%1
SET SET_JOPT_JAR=on
shift
if "X%1"=="X" goto make
if %1==-help goto error
if %1==-jdkhome goto jdkhome
if %1==-mavenhome goto mavenhome
if %1==-prefix goto error
if %1==-release goto release
if %1==-compiler goto compiler
if %1==-optimize goto optimize
if %1==-debug goto debug
goto error



:callmavenhomeconfig
"%JDKHOME%\bin\java" org.apache.tools.ant.Main -DSYSTEMROOT=%SYSTEMROOT% mavenhomeconfig
goto end

:end
SET JDKHOME=
SET INSTALLDIR=
SET MAVENHOME=
SET RELEASE=
SET BUILD_COMPILER=
SET BUILD_OPTIMIZE=
SET BUILD_DEBUG=
SET JOPT_JAR=

SET SET_RELEASE=
SET SET_JDKHOME=
SET SET_INSTALLDIR=
SET SET_MAVENHOME=
SET SET_BUILD_COMPILER=
SET SET_BUILD_OPTIMIZE=
SET SET_BUILD_DEBUG=
SET SET_JOPT_JAR=