@echo off
cls

SET OLD_JAVA_HOME=%JAVA_HOME%
SET OLD_MAVEN_HOME=%MAVEN_HOME%

find "jdk.dir" < build.properties > javahome.txt
for /F "tokens=1,2* delims==" %%i in (javahome.txt) do SET JAVA_HOME=%%j
del javahome.txt>nul
if "X%JAVA_HOME%"=="X" goto javacontinue

find "maven.path" < build.properties > mavendir.txt
for /F "tokens=1,2* delims==" %%i in (mavendir.txt) do SET MAVEN_HOME=%%j
del mavendir.txt>nul
if "X%MAVEN_HOME%"=="X" goto mavenhomecontinue

SET TARGET=buildAll

if %SYSTEMROOT% == "" goto errorsystemroot
if not exist build.properties call configure.bat
if "X%1"=="X" goto buildAll
if %1==help goto help
if %1==install goto install
if %1==buildAll goto continue
if %1==buildNoDoc goto continue
if %1==distributions goto buildDistributions
if %1==clean goto continue
if %1==test goto continue
if %1==buildCsvJdbc goto continue
if %1==buildXmlJdbc goto continue
if %1==buildOctopus goto continue
if %1==buildGenerator goto continue
if %1==buildXmlutil goto continue
if %1==buildFreetds goto continue
if %1==buildOctopusTest goto continue
if %1==buildOctopusTask goto continue
if %1==buildLog4jlogger goto continue
if %1==buildI18njdbc goto continue
goto error

:continue
SET TARGET=%1
goto continuebuild

:buildAll
SET TARGET=buildAll
goto continuebuild

:installWithBuildAll
SET TARGET=buildAll
set OLDCLASSPATH=%CLASSPATH%
set CLASSPATH=%CLASSPATH%;.\..\maven\lib\ant-1.5.1.jar
set CLASSPATH=%CLASSPATH%;%JAVA_HOME%\lib\tools.jar
"%JAVA_HOME%/bin/java.exe" org.apache.tools.ant.Main -DSYSTEMROOT=%SYSTEMROOT% %TARGET%
set CLASSPATH=%OLDCLASSPATH%
set OLDCLASSPATH=
echo.
echo Install and configure Octopus, please wait ...
echo.
xcopy .\output\octopus-2.2\*.* %INSTDIR% /e /h /i /y
echo %INSTDIR%
goto end

:buildDistributions
SET TARGET=buildDistribution
goto continuebuild

:continuebuild
set OLDCLASSPATH=%CLASSPATH%
set CLASSPATH=%CLASSPATH%;.\..\maven\lib\ant-1.5.1.jar
set CLASSPATH=%CLASSPATH%;%JAVA_HOME%\lib\tools.jar
set PATH=%PATH%;%MAVEN_HOME%\lib

"%JAVA_HOME%/bin/java.exe" org.apache.tools.ant.Main -DSYSTEMROOT=%SYSTEMROOT% %TARGET%
set CLASSPATH=%OLDCLASSPATH%
set OLDCLASSPATH=
goto end

:help
echo.
echo Please use one of the following options:
echo.
echo make                   - build Octopus with documentation
echo make help              - Display this screen
echo make install           - Copy and configure builted octopus in prefix
echo make buildAll          - build Octopus with documentation
echo make buildNoDoc        - build Octopus without documentation
echo make distributions     - build Octopus installation
echo make test              - run Octopus tests
echo make clean             - cleans everything
echo make buildCsvJdbc      - build CsvJdbc. Can be call only after buildNoDoc or buildAll.
echo make buildXmlJdbc      - build XmlJdbc. Can be call only after buildNoDoc or buildAll.
echo make buildOctopus      - build Octopus. Can be call only after buildNoDoc or buildAll.
echo make buildGenerator    - build OctopusGenerator. Can be call only after buildNoDoc or buildAll.
echo make buildXmlutil      - build Xmlutil. Can be call only after buildNoDoc or buildAll.
echo make buildFreetds      - build Freetds. Can be call only after buildNoDoc or buildAll.
echo make buildOctopusTest  - build OctopusTest. Can be call only after buildNoDoc or buildAll.
echo make buildOctopusTask  - build OctopusTask. Can be call only after buildNoDoc or buildAll.
echo make buildLog4jlogger  - build Log4jlogger. Can be call only after buildNoDoc or buildAll.
echo make buildI18njdbc     - build buildI18njdbc. Can be call only after buildNoDoc or buildAll.
goto end

:install
find "prefix" < build.properties > outputdir.txt
for /F "tokens=1,2* delims==" %%i in (outputdir.txt) do SET INSTDIR=%%j
del outputdir.txt>nul
if "X%INSTDIR%"=="X" goto message
echo.
echo Install and configure Octopus, please wait ...
echo.
if not exist .\output goto installWithBuildAll
xcopy .\output\octopus-2.2\*.* %INSTDIR% /e /h /i /y
echo %INSTDIR%
goto end

:mavenhomecontinue
echo.
echo You must define maven.path parameter in build.properties file.
echo Use configure to set maven.path parameter in build.properties file.
echo.
goto end

:javacontinue
echo.
echo You must define jdk.dir variable in build.properties
echo Use configure to set jdk.dir parameter in build.properties file.
echo.
goto end

:errorsystemroot
echo.
echo          Enviroment variable SYSTEMROOT does not exist.
echo.
echo Set variable SYSTEMROOT to system root of your Windows installation ...
echo.
pause
goto end

:error
echo.
echo Invalid parameters value
echo.
goto help

:message
echo.
echo.
echo Octopus will be installed to directory defined with parameter
echo prefix from build.properties file. You must set value for this parameter.
echo This can be done using next syntax :
echo.
echo     configure.bat -prefix install_directory
echo.
goto end

:end
SET JAVA_HOME=%OLD_JAVA_HOME%
SET MAVEN_HOME=%OLD_MAVEN_HOME%
SET TARGET=