//
// Copyright 1999 Craig Spannring
//
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 3. All advertising materials mentioning features or use of this software
//    must display the following acknowledgement:
//      This product includes software developed by Craig Spannring
// 4. The name of Craig Spannring may not be used to endorse or promote
//    products derived from this software without specific prior
//    written permission.
//
// THIS SOFTWARE IS PROVIDED BY CRAIG SPANNRING ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL CRAIG SPANNRING BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.
//
package com.internetcds.jdbc.tds;

import java.sql.*;
import java.net.URL;
import java.math.BigDecimal;
import java.io.InputStream;
import java.io.Reader;
import java.util.Calendar;
import java.util.Map;

public class CallableStatement_2_0 
   extends    com.internetcds.jdbc.tds.CallableStatement_base
   implements java.sql.CallableStatement
{
   public static final String cvsVersion = "$Id: CallableStatement_2_0.java,v 1.1 2003/04/29 18:07:50 sinisa Exp $";


   public CallableStatement_2_0(
      java.sql.Connection conn_, 
      Tds                 tds_, 
      String              sql)
      throws java.sql.SQLException
   {
      super(conn_, tds_, sql);
   }


   /**
    * JDBC 2.0
    *
    * Gets the value of a JDBC <code>BLOB</code> parameter as a
    * {@link Blob} object in the Java programming language.
    * @param i the first parameter is 1, the second is 2, and so on
    * @return the parameter value as a <code>Blob</code> object in the
    * Java programming language.  If the value was SQL NULL, the value
    * <code>null</code> is returned.
    * @exception SQLException if a database access error occurs
    */
   public Blob getBlob (int i) throws SQLException
   {
      NotImplemented();
      return null;
   }
   
   /**
    * JDBC 2.0
    *
    * Gets the value of a JDBC <code>CLOB</code> parameter as a
    * <code>Clob</code> object in the Java programming language.
    * @param i the first parameter is 1, the second is 2, and
    * so on
    * @return the parameter value as a <code>Clob</code> object in the
    * Java programming language.  If the value was SQL NULL, the
    * value <code>null</code> is returned.
    * @exception SQLException if a database access error occurs
    */
   public Clob getClob (int i) throws SQLException
   {
      NotImplemented();
      return null;
   }

   
   /**
    * JDBC 2.0
    *
    * Returns an object representing the value of OUT parameter 
    * <code>i</code> and uses <code>map</code> for the custom
    * mapping of the parameter value.
    * <p>
    * This method returns a Java object whose type corresponds to the
    * JDBC type that was registered for this parameter using the method
    * <code>registerOutParameter</code>.  By registering the target
    * JDBC type as <code>java.sql.Types.OTHER</code>, this method can
    * be used to read database-specific abstract data types.  
    * @param i the first parameter is 1, the second is 2, and so on
    * @param map the mapping from SQL type names to Java classes
    * @return a java.lang.Object holding the OUT parameter value.
    * @exception SQLException if a database access error occurs
    */
   public Object  getObject (int i, java.util.Map map) throws SQLException
   {
      NotImplemented();
      return null;
   }

   
   /**
    * JDBC 2.0
    *
    * Gets the value of a JDBC <code>REF(&lt;structured-type&gt;)</code>
    * parameter as a {@link Ref} object in the Java programming language.
    * @param i the first parameter is 1, the second is 2, 
    * and so on
    * @return the parameter value as a <code>Ref</code> object in the
    * Java programming language.  If the value was SQL NULL, the value
    * <code>null</code> is returned.
    * @exception SQLException if a database access error occurs
    */
   public Ref getRef (int i) throws SQLException
   {
      NotImplemented();
      return null;
   }


   /**
    * JDBC 2.0
    *
    * Gets the value of a JDBC <code>ARRAY</code> parameter as an
    * {@link Array} object in the Java programming language.
    * @param i the first parameter is 1, the second is 2, and 
    * so on
    * @return the parameter value as an <code>Array</code> object in
    * the Java programming language.  If the value was SQL NULL, the
    * value <code>null</code> is returned.
    * @exception SQLException if a database access error occurs
    */
   public Array getArray (int i) throws SQLException
   {
      NotImplemented();
      return null;
   }


   public void setClob (int i, java.sql.Clob x) throws java.sql.SQLException
   {
      //  XXX should be inherited PreparedStatement_2_0
      NotImplemented();
   }

   public void addBatch() throws java.sql.SQLException
   {
      //  XXX should be inherited PreparedStatement_2_0
      NotImplemented();
   }

   public void setBlob (int i, java.sql.Blob x) throws java.sql.SQLException
   {
      //  XXX should be inherited PreparedStatement_2_0
      NotImplemented();
   }

   public void setArray (int i, java.sql.Array x) throws java.sql.SQLException
   {
      //  XXX should be inherited PreparedStatement_2_0
      NotImplemented();
   }


   public void setRef (int i, java.sql.Ref x) throws java.sql.SQLException
   {
      //  XXX should be inherited PreparedStatement_2_0
      NotImplemented();
   }


   public void setCharacterStream(int parameterIndex,
                                  java.io.Reader reader,
                                  int length) throws java.sql.SQLException
   {
      //  XXX should be inherited PreparedStatement_2_0
      NotImplemented();
   }

   public java.sql.ResultSetMetaData getMetaData() throws java.sql.SQLException
   {
      //  XXX should be inherited PreparedStatement_2_0
      NotImplemented();
      return null;
   }
   public void setNull (int paramIndex, int sqlType, String typeName) 
      throws java.sql.SQLException
   {
      //  XXX should be inherited PreparedStatement_2_0
      NotImplemented();
   }

   public void setTimestamp(int parameterIndex, java.sql.Timestamp x, java.util.Calendar cal)
      throws java.sql.SQLException
   {
      //  XXX should be inherited PreparedStatement_2_0
      NotImplemented();
   }

   public void setDate(int parameterIndex, java.sql.Date x, java.util.Calendar cal)
      throws java.sql.SQLException
   {
      //  XXX should be inherited PreparedStatement_2_0
      NotImplemented();
   }

   public void setTime(int parameterIndex, java.sql.Time x, java.util.Calendar cal) 
      throws java.sql.SQLException
   {
      NotImplemented();
   }


    //---------------------------------------------------------------------
    // JDBC 3.0
    //---------------------------------------------------------------------

    public void setURL(int current, URL url) throws SQLException {
        throw new UnsupportedOperationException("Statement.getMoreResults(int) unsupported");
    }
    
    public void setURL(String current, URL url) throws SQLException {
        throw new UnsupportedOperationException("Statement.getMoreResults(int) unsupported");
    }

    public boolean getMoreResults(int current) throws SQLException {
        throw new UnsupportedOperationException("Statement.getMoreResults(int) unsupported");
    }

    public ResultSet getGeneratedKeys() throws SQLException {
        throw new UnsupportedOperationException("Statement.getGeneratedKeys() unsupported");
    }

    public int executeUpdate(String sql, int autoGeneratedKeys) throws SQLException {
        throw new UnsupportedOperationException("Statement.executeUpdate(String,int) unsupported");
    }

    public int executeUpdate(String sql, int[] columnIndexes) throws SQLException {
        throw new UnsupportedOperationException("Statement.executeUpdate(String,int[]) unsupported");
    }

    public int executeUpdate(String sql, String[] columnNames) throws SQLException {
        throw new UnsupportedOperationException("Statement.executeUpdate(String,String[]) unsupported");
    }

    public boolean execute(String sql, int autoGeneratedKeys) throws SQLException {
        throw new UnsupportedOperationException("Statement.execute(String,int) unsupported");
    }

    public boolean execute(String sql, int[] columnIndexes) throws SQLException {
        throw new UnsupportedOperationException("Statement.execute(String,int[]) unsupported");
    }

    public boolean execute(String sql, String[] columnNames) throws SQLException {
        throw new UnsupportedOperationException("Statement.execute(String,String[]) unsupported");
    }

    public int getResultSetHoldability() throws SQLException {
        throw new UnsupportedOperationException("Statement.getResultSetHoldability() unsupported");
    }

    public java.sql.ParameterMetaData getParameterMetaData() throws SQLException {
        throw new UnsupportedOperationException("Statement.getParameterMetaData() unsupported");
    }

    public void registerOutParameter(String str,int x) throws SQLException {
        throw new UnsupportedOperationException("Statement.getParameterMetaData() unsupported");
    }

    public void registerOutParameter(String str,int x, int y) throws SQLException {
        throw new UnsupportedOperationException("Statement.getParameterMetaData() unsupported");
    }

    public void registerOutParameter(String str1,String str2) throws SQLException {
        throw new UnsupportedOperationException("Statement.getParameterMetaData() unsupported");
    }
    public void registerOutParameter(String str1,int x,String str2) throws SQLException {
        throw new UnsupportedOperationException("Statement.getParameterMetaData() unsupported");
    }

    public URL getURL(int url) throws SQLException {
        throw new UnsupportedOperationException("Statement.getMoreResults(int) unsupported");
    }
    
    public void setNull(String column, int url) throws SQLException {
        throw new UnsupportedOperationException("Statement.getMoreResults(int) setNull");
    }
    
    public void setBoolean(String str,boolean b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setBoolean(int) setNull");
    }

    public void setByte(String str,byte b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }


    public void setShort(String str,short b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }
    
    
    public void setInt(String str,int b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }
    
    
    public void setLong(String str,long b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }
    
    
    public void setFloat(String str,float b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }


    public void setDouble(String str,double b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }
    
    
    public void setBigDecimal(String str,BigDecimal b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }


    public void setString(String str,String b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }

    public void setBytes(String str,byte[] b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }

    public void setDate(String str,Date b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }

    public void setTime(String str,Time b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }

    public void setTimestamp(String str,Timestamp b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }
    
   public void setAsciiStream(String str,InputStream b, int x) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }

  public void setBinaryStream(String str,InputStream b, int x) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }
    
  public void setObject(String str,Object b, int x, int y) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

  public void setObject(String str,Object b, int x) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

  public void setObject(String str,Object b) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
  public void setCharacterStream(String str,Reader b, int x) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

  public void setDate(String str,Date b, Calendar cal) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

  public void setTime(String str,Time b, Calendar cal) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
  public void setTimestamp(String str,Timestamp b, Calendar cal) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

  public void setNull(String str,int b, String str2) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }      

  public String getString(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }      
    
  public boolean getBoolean(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
  public byte getByte(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
  public short getShort(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

  public int getInt(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
  public long getLong(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
  public float getFloat(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
  
  public double getDouble(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

  public byte[] getBytes(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
  public Date getDate(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
  public Time getTime(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
  public Timestamp getTimestamp(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
    public Object getObject(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
    public BigDecimal getBigDecimal(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
    public Object getObject(String str, Map m) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

    public Ref getRef(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
  
  
    public Blob getBlob(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

   public Clob getClob(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
   public Array getArray(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
 
 
   public Date getDate(String str, Calendar c) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

  public Time getTime(String str, Calendar m) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  

    public Timestamp getTimestamp(String str, Calendar m) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  
    
   public URL getURL(String str) throws SQLException {
        throw new UnsupportedOperationException("Statement.setByte(int) setNull");
    }  



  
  
 

}
