/*

  Loader - tool for transfering data from one JDBC source to another and
  doing transformations during copy.

    Copyright (C) 2002-2003  Together

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 Loader.java
 Date: 03.03.2003.
 @version 2.1 alpha
 @author:
 Radoslav Dutina rale@prozone.co.yu

*/

package org.webdocwf.util.loader;

import java.io.*;
import java.sql.*;
import java.util.*;

/**
 *
 * LocationOfException class provide exact line where exception are happened
 * @author Radoslav Dutina
 * @version 1.0
 */
public class LocationOfException {

  private static int introNumber=0;
  private static int dtdNumber=0;
  private static int jdbcNumber=0;
  private static Vector fileLineNumber=new Vector();
  private static String fileName="";
  private static int exceptionNumber=0;
  private static String baseFile="";
  private static int createDropNumber=0;



  /**
   * This constructor set value of base xml file
   * @param baseFileName is name of base xml file
   */
  public LocationOfException(String baseFileName) {
    baseFile=baseFileName;
  }

  /**
   * This method set value of introNumber parameter
   * @param lineNumber is value of parmeter
   */
  public static void setIntroNumber(int lineNumber){
    introNumber=lineNumber;
  }

  /**
   * This method set value of dtdNumber parameter
   * @param lineNumber is value of parameter
   */
  public static void setDtdNumber(int lineNumber){
    dtdNumber=lineNumber;
  }

  /**
   * This method set value of jdbcNumber parameter
   * @param lineNumber is value of parameter
   */
  public static void setJdbcNumber(int lineNumber){
    jdbcNumber=lineNumber;
  }

  /**
   * This method set value of fileLineNumber parameter
   * @param lineNumber is secunde value of pratemeter
   * @param fileName is first value of parameter
   */
  public static void setFileLineNumber(int lineNumber, String fileName){
    fileLineNumber.add(String.valueOf(lineNumber));
    fileLineNumber.add(fileName);
  }

  /**
   * This method read value of exceptionNumber parameter
   * @param number is line number of exception
   * @return value of parameter
   */
  public static int getLineNumber(int number){
    int temp1=introNumber+dtdNumber+jdbcNumber;
    if(number<introNumber){
      fileName=baseFile;
    }else if(number>introNumber && number<=introNumber+dtdNumber){
      fileName="Dtd file which match "+baseFile;
    }else if(number>introNumber+dtdNumber && number<=temp1){
      fileName=baseFile;
      exceptionNumber=jdbcNumber-(temp1-number)+3;
    }else{
      for(int i=0;i<fileLineNumber.size();i=i+2){
        if(number>temp1 && number<temp1+Integer.parseInt(fileLineNumber.get(i).toString())){
          fileName=fileLineNumber.get(i+1).toString();
          exceptionNumber=Integer.parseInt(fileLineNumber.get(i).toString())-
                          ((temp1+Integer.parseInt(fileLineNumber.get(i).toString()))-number);
          break;
        }else{
          temp1+=Integer.parseInt(fileLineNumber.get(i).toString());
        }
      }
    }
    return exceptionNumber-1;
  }

  /**
   * This method read value of fileName parameter
   * @return value of parameter
   */
  public static String getFileName(){
    return fileName;
  }
}