/**
  ReturnCode - If some element of loadjobs fails, the java.exe has to return
  a ReturnCode to the environment.

    Copyright (C) 2002-2003  Together

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 ReturnCode.java
 Date: 01.03.2003.
 Author: Milosevic Sinisa sinisa@prozone.co.yu
 @version 1.0.0
 */

package org.webdocwf.util.loader;

/**
  ReturnCode - If some element of loadjobs fails, the java.exe has to return
  a ReturnCode to the environment.
*/
public class ReturnCode {

  private static int returnError=1;
  private static int defaultReturnError=1;
  private static int returnOK=0;
  public static boolean isParameter=false;


  /**
   * Read return code for normal end of java program
   * @return int return code
   */
  public static int getOKReturnCode() {
    return returnOK;
  }


  /**
   * Set return code for normal end of program.
   * @param code is new value of return code.
   */
  public static void setOKReturnCode(int code) {
    returnOK=code;
  }


  /**
   * Read current error return code
   * @return int return code
   */
  public static int getErrorReturnCode() {
    return returnError;
  }


  /**
   * Set current error return code.
   * @param code is new value of return code.
   */
  public static void setErrorReturnCode(int code) {
    returnError=code;
  }


  /**
   * Read default error return code
   * @return int return code
   */
  public static int getDefaultErrorReturnCode() {
    return defaultReturnError;
  }


  /**
   * Set default error return code.
   * @param code is new value of default return code.
   */
  public static void setDefaultErrorReturnCode(int code) {
    defaultReturnError=code;
  }

}