/**
    Copyright (C) 2002-2003  Together

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
package org.webdocwf.util.loader;

import java.io.*;
import java.util.*;

/**
 * Utility methods for csv jdbc.
 *
 * @author     Zoran Milakovic
 */

public class Utils {

  /**
   * Replace all occurence of forReplace with replaceWith in input string.
   * @param input represents input string
   * @param forReplace represents substring for replace
   * @param replaceWith represents replaced string value
   * @return new string with replaced values
   */
  public static String replaceAll(String input, String forReplace,
                                  String replaceWith) {
    if( input == null )
      return "null";
      //return null;
    StringBuffer result = new StringBuffer();
    boolean hasMore = true;
    while (hasMore) {
      int start = input.indexOf(forReplace);
      int end = start + forReplace.length();
      if (start != -1) {
        result.append(input.substring(0, start) + replaceWith);
        input = input.substring(end);
      }
      else {
        hasMore = false;
        result.append(input);
      }
    }
    if (result.toString().equals(""))
      return input; //nothing is changed
    else
      return result.toString();
  }


  public static String handleQuotedString(String quotedString) {
    if( quotedString == null )
      return "null";
      //return null;
    String retVal = quotedString;
    if ( (retVal.startsWith("'") && retVal.endsWith("'"))) {
      if (!retVal.equals("''")) {
        retVal = retVal.substring(retVal.indexOf("'") + 1,
                                  retVal.lastIndexOf("'"));
      }
      else {
        retVal = "";
      }
    }
    //else {
    //  if( retVal.equals("null") )
    //    retVal = null;
    //}
    return retVal;
  }


public static String getAbsolutePathFromDatabaseURL(String urlPrefix,
      String loaderJobFile, String urlToDatabase, boolean fileSystemDatabase) {

  if(fileSystemDatabase==true){
    String pathToDatabase=urlToDatabase.substring(urlPrefix.length());
    File file=new File(pathToDatabase);
    if (!file.isAbsolute()){
      pathToDatabase=loaderJobFile + pathToDatabase;
      File absolutePath=new File(pathToDatabase);
      try {
        pathToDatabase=absolutePath.getCanonicalPath();
      }
      catch (Exception ex) {
      ex.printStackTrace();
      }
      urlToDatabase = urlToDatabase.substring(0, (urlPrefix.length())) +
                      pathToDatabase;
    }
  }
  return urlToDatabase;
}

public static void log(String msg) {
	try {
			File file = new File("c:/log.txt");
			if (!file.exists()) {
			  file.createNewFile();
			}
			RandomAccessFile fileLogr = new RandomAccessFile("c:/log.txt", "rw");
			fileLogr.seek(fileLogr.length());
			fileLogr.writeBytes( msg + "\r\n");
			fileLogr.close();
		}
		catch (Exception ex) {
		  ex.printStackTrace();
		}
}




}
