/**
  Transformer - Transformer interface.
    Copyright (C) 2002-2004  Together
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 Transformation.java
 Date: 05.04.2004.
 @version 1.0
 @author: Milosevic Sinisa sinisa@prozone.co.yu
 */

package org.webdocwf.util.loader.transformation;

import java.util.List;

public interface Transformer {

	/**
	 * Configure transformer
	 */
	public void configure(String s) throws Exception;
	
	/**
	 * Release resources if necessairly
	 */
	public void release() throws Exception;

	/**
	 * This method return List with transformed values for source column(s).
	 */
	public List transformValue(List valueToTransform) throws Exception;

}


