/*
* RunTest.java   Sept 01, 2002
*
* Sample JUnit test using Loader for creating test database and
* inserting data into it.
*
 */

package test.org.webdocwf.util.loader;

import junit.framework.*;
import java.io.*;
import java.sql.*;

/**
 * RunTest is the main class for starting tests of the Octopus application
 * @author Radoslav Dutina
 * @version 1.0
 */
public class RunTests
{

  /**
   * This method starts test
   * @return TestSuite object
   */
  public static Test suite()
  {
    TestSuite suite= new TestSuite();
    suite.addTestSuite(LoaderTest.class);
    suite.addTestSuite(LoaderTest2.class);
    suite.addTestSuite(LoaderTest3.class);
    return suite;
  }

  /**
   * This is the main method of the RunTest class
   * @param args is the input parameters
   */
  public static void main(String[] args)
  {
    // set the file location as a property so that it is easy to pass around
    System.setProperty(LoaderTest.DATABASE_LOCATION_PROPERTY,args[0]);


    // kick off the tests. Note call main() instead of run() so that error codes
    // are returned so that they can be trapped by ant
    junit.textui.TestRunner.main(new String[]{"test.org.webdocwf.util.loader.RunTests"});
  }
}