
/*
LoaderGenerator - tool for generated xml, sql and doml file needed for Octopus.


    Copyright (C) 2003  Together

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package org.webdocwf.util.loader.generator;


/**
 * ImportDefinitionAttributes class  stores the value of Import definition tag parameters, which
 * are needed for creating ImportDefinition.xml file.w2
 * @author Radoslav Dutina
 * @version 1.0
 */
public class ImportDefinitionAttributes {


  private String name="Table1";
  private String tableName="TableName1";
  private String logMode="normal";
  private String objectIDIncrementid="20";

  private String[] tagSourceColumnName={"default"};
  private String[] tagTargetTableName={"default"};
  private String[] tagTargetColumnName={"default"};
  private String[] tagTargetTableID={"default"};

  private String[] tagColumnType={"default"};
  private String[] tagAllowNulls= {"default"};
  private String[] tagColumnLenght={"default"};


  /**
   * This method sets the value of name parameter.
   * @param _name is the value of parameter.
   */
  public void setName(String _name){
    name=_name;
  }

  /**
   * This method read the value of name parameter.
   * @return value of parameter.
   */
  public String getName(){
    return name;
  }

  /**
   * This method sets the value of tableName parameter.
   * @param table_Name is the value of parameter.
   */
  public void setTableName(String table_Name){
    tableName=table_Name;
  }

  /**
   * This method read the value of tableName parameter.
   * @return value of parameter.
   */
  public String getTableName(){
    return tableName;
  }

  /**
   * This method sets the value of logMode parameter.
   * @param log_Mode is the value of parameter.
   */
  public void setLogMode(String log_Mode){
    logMode=log_Mode;
  }

  /**
   * This method read the value of logMode parameter.
   * @return value of parameter.
   */
  public String getLogMode(){
    return logMode;
  }

  /**
   * This method sets the value of objectIDIncrementid parameter.
   * @param object_ID_Incrementid is the value of parameter.
   */
  public void setObjectIDIncrementid(String object_ID_Incrementid){
    objectIDIncrementid=object_ID_Incrementid;
  }

  /**
   * This method read the value of objectIDIncrementid parameter.
   * @return value of parameter.
   */
  public String getObjectIDIncrementid(){
    return objectIDIncrementid;
  }

  /**
   * This method sets the value of tagSourceColumnName parameter.
   * @param tag_Source_ColumnName is the value of parameter.
   */
  public void setTagSourceColumnName(String[] tag_Source_ColumnName){
    tagSourceColumnName=tag_Source_ColumnName;
  }

  /**
   * This method read the value of tagSourceColumnName parameter.
   * @return value of parameter.
   */
  public String[] getTagSourceColumnName(){
    return   tagSourceColumnName;
  }

  /**
   * This method sets the value of tagTargetTableName parameter.
   * @param tag_Target_TableName is the value of parameter.
   */
  public void setTagTargetTableName(String[] tag_Target_TableName){
    tagTargetTableName=tag_Target_TableName;
  }

  /**
   * This method read the value of tagTargetTableName parameter.
   * @return value of parameter.
   */
  public String[] getTagTargetTableName(){
    return   tagTargetTableName;
  }

  /**
   * This method sets the value of tagTargetColumnName parameter.
   * @param tag_Target_ColumnName is the value of parameter.
   */
  public void setTagTargetColumnName(String[] tag_Target_ColumnName){
    tagTargetColumnName=tag_Target_ColumnName;
  }

  /**
   * This method read the value of tagTargetColumnName parameter.
   * @return value of parameter.
   */
  public String[] getTagTargetColumnName(){
    return   tagTargetColumnName;
  }

  /**
   * This method sets the value of tagTargetTableID parameter.
   * @param tag_Target_TableID is the value of parameter.
   */
  public void setTagTargetTableID(String[] tag_Target_TableID){
    tagTargetTableID=tag_Target_TableID;
  }

  /**
   * This method read the value of tagTargetTableID parameter.
   * @return value of parameter.
   */
  public String[] getTagTargetTableID(){
    return   tagTargetTableID;
  }

  /**
   * This method sets the value of tagColumnType parameter.
   * @param tag_ColumnType is the value of parameter.
   */
  public void setTagColumnType(String[] tag_ColumnType){
    tagColumnType=tag_ColumnType;
  }

  /**
   * This method read the value of tagColumnType parameter.
   * @return value of parameter.
   */
  public String[] getTagColumnType(){
    return   tagColumnType;
  }

  /**
   * This method sets the value of tagAllowNulls parameter.
   * @param tag_AllowNulls is the value of parameter.
   */
  public void setTagAllowNulls(String[] tag_AllowNulls){
    tagAllowNulls=tag_AllowNulls;
  }

  /**
   * This method read the value of tagAllowNulls parameter.
   * @return value of parameter.
   */
  public String[] getTagAllowNulls(){
    return   tagAllowNulls;
  }

  /**
   * This method sets the value of tagColumnLenght parameter.
   * @param tag_ColumnLenght is the value of parameter.
   */
  public void setTagColumnLenght(String[] tag_ColumnLenght){
    tagColumnLenght=tag_ColumnLenght;
  }

  /**
   * This method read the value of tagColumnLenght parameter.
   * @return value of parameter.
   */
  public String[] getTagColumnLenght(){
    return   tagColumnLenght;
  }


}