
/*
LoaderGenerator - tool for generated xml, sql and doml file needed for Octopus.


    Copyright (C) 2003  Together

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package org.webdocwf.util.loader.generator;

/**
 * LoaderJobAttributes class stores the parameters of loadJob tag for LoaderJob.xml file.
 * @author Radoslav Dutina
 * @version 1.0
 */
public class LoaderJobAttributes {

  public final String loaderJob = "loaderJob";
  private String logMode="none";
  private String objectIDIncrement="1";
  private String objectIDTableName="objectid";
  private String objectIDColumnName="next";

  /**
   * This method sets the value of logMode parameter.
   * @param log_mode is value of parameter.
   */
  public void setLogMode(String log_mode){
    logMode=log_mode;
  }

  /**
   * This method read the value of logMode parameter.
   * @return value of parameter.
   */
  public String getLogMode(){
    return logMode;
  }

  /**
   * This method sets the value of objectIDIncrement parameter.
   * @param object_ID_Increment is value of parameter.
   */
  public void setObjectIDIncrement(String object_ID_Increment){
    objectIDIncrement=object_ID_Increment;
  }

  /**
   * This method read the value of objectIDIncrement parameter.
   * @return value of parameter.
   */
  public String getObjectIDIncrement(){
    return objectIDIncrement;
  }

  /**
   * This method sets the value of objectIDTableName attribute.
   * @param object_ID_TableName is value of attribute.
   */
  public void setObjectIDTableName(String object_ID_TableName){
    objectIDTableName=object_ID_TableName;
  }

  /**
   * This method read the value of objectIDTableName attribute.
   * @return value of attribute.
   */
  public String getObjectIDTableName(){
    return objectIDTableName;
  }

  /**
   * This method sets the value of objectIDColumnName parameter.
   * @param object_ID_ColumnName is value of parameter.
   */
  public void setObjectIDColumnName(String object_ID_ColumnName){
    objectIDColumnName=object_ID_ColumnName;
  }

  /**
   * This method read the value of objectIDColumnName parameter.
   * @return value of parameter.
   */
  public String getObjectIDColumnName(){
    return objectIDColumnName;
  }

}