
/*
LoaderGenerator - tool for generated xml, sql and doml file needed for Octopus.


    Copyright (C) 2003  Together

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package org.webdocwf.util.loader.generator;


/**
 *
 * RelationshipsAttributes class stores the value of table relationships parameters,
 * such as primary keys, indexes, foreign key, and table names.
 * @author Radoslav Dutina
 * @version 1.0
 */
public class RelationshipsAttributes {

  private static String tableName;
  private static String[] primaryKeys={"This table has no primary keys!"};
  private static String[] indexVariables={"This table has no indexes keys!"};
  private static String[] foreignVariables={"This table has no foreign keys!"};


  /**
   * This method sets the value of tableName parameter.
   * @param table_Name is the value of parameter.
   */
  public static void setTableName(String table_Name){
    tableName=table_Name;
  }

  /**
   * This method read the value of tableName parameter.
   * @return value of parameter.
   */
  public static String getTableName(){
    return tableName;
  }

  /**
   * This method sets the value of primaryKeys parameter.
   * @param primary_Keys is the value of parameter.
   */
  public static void setPrimaryKeys(String[] primary_Keys){
    primaryKeys=primary_Keys;
  }

  /**
   * This method read the value of primaryKeys parameter.
   * @return value of parameter.
   */
  public static String[] getPrimaryKeys(){
    return primaryKeys;
  }

  /**
   * This method sets the value of indexVariables parameter.
   * @param index_Variables is the value of parameter.
   */
  public static void setIndexVariables(String[] index_Variables){
    indexVariables=index_Variables;
  }

  /**
   * This method read the value of indexVariables parameter.
   * @return value of parameter.
   */
  public static String[] getIndexVariables(){
    return indexVariables;
  }

  /**
   * This method sets the value of foreignVariables parameter.
   * @param foreign_Variables is the value of parameter.
   */
  public static void setForeignVariables(String[] foreign_Variables){
   
    foreignVariables=foreign_Variables;
  }

  /**
   * This method read the value of foreignVariables parameter.
   * @return value of parameter.
   */
  public static String[] getForeignVariables(){
    return foreignVariables;
  }

  /**
   *This method reset all parameters.
   */
  public static void resetAllVariables(){
    tableName="";
    primaryKeys=null;
    indexVariables=null;
    foreignVariables=null;

  }

}