/*
LoaderGenerator - tool for generated xml, sql and doml file needed for Octopus.


    Copyright (C) 2003  Together

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package org.webdocwf.util.loader.wizard;

import java.io.File;

/**
 * DirectoryFilter restricts file sets to only those files that are
 * directories. Use this with JFileChooser to create a directory
 * chooser.
 *
 * @author Radoslav Dutina
 * @version 1.0
 */
public class DirectoryFilter extends javax.swing.filechooser.FileFilter {

    /**
     * Create a DirectoryFilter for use with the FileChooser dialog.
     */
    public DirectoryFilter() {}

    /**
     * Check to see if the passed file is a directory.
     *
     * @param f File to check.
     *
     * @return True if the file is a directory.
     *
     */
    public boolean accept(File f) {
        return f.isDirectory();
    }

    /**
     * Get a description of this filter.
     *
     * @return The description of this filter.
     *
     */
    public String getDescription() {
        return new String("Directories");
    }
}
