/*
LoaderGenerator - tool for generated xml, sql and doml file needed for Octopus.


    Copyright (C) 2003  Together

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package org.webdocwf.util.loader.wizard;

import java.io.BufferedReader;
import java.io.PrintStream;
import java.io.IOException;


/**
 * This thread is used for reading error messages occured while executing process.
 */
public class ErrorReader extends Thread {
    BufferedReader er;
    boolean trace = false;
    /**
     * Constructor.
     *
     * @param bufferedReader buffer reading that reads error messages.
     */
    public ErrorReader(BufferedReader bufferedReader) {
        er = bufferedReader;
    }

    /**
     * Constructor.
     *
     * @param bufferedReader buffer reading that reads error messages.
     * @param trace shows error messages trace.
     */
    public ErrorReader(BufferedReader bufferedReader, boolean trace) {
        er = bufferedReader;
        this.trace = trace;
    }

    /**
     * Run the thread
     */
    public void run() {
        try {
            for(; !er.ready(); Thread.sleep(100L)) { }
            String s;
            while((s = er.readLine()) != null) {
                if (trace)
                    System.out.println(s+"\n");
            }
        } catch (IOException e) {
        } catch (InterruptedException e) {
        }
    }
}
