
/*
LoaderGenerator - tool for generated xml, sql and doml file needed for Octopus.


    Copyright (C) 2003  Together

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package org.webdocwf.util.loader.wizard;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.net.URL;




/**
 *
 * OctopusGeneratorHelpFrame class creates the help frame
 * @author Radoslav Dutina
 * @version 1.0
 */
public class OctopusGeneratorHelpFrame extends JFrame{

  private OctopusHelpToolBar toolBar;
  private OctopusHelpPane browserPane;
  private OctopusHelpPane favoritesBrowserPane;




private StringBuffer help = new StringBuffer();

/**
 * Construct the object of OctopusGeneratorHelpFrame class
 */
public OctopusGeneratorHelpFrame() {
    super("Help for Enhydra Octopus" );

    browserPane=new OctopusHelpPane();
    toolBar=new OctopusHelpToolBar(browserPane);
    favoritesBrowserPane=new OctopusHelpPane();
    favoritesBrowserPane.addHyperlinkListener(toolBar);

    JPanel leftPanel=new JPanel();
    leftPanel.setLayout(new BoxLayout(leftPanel,BoxLayout.Y_AXIS));
    JPanel buttonPanel=new JPanel();
    JButton button = new JButton("Close Help ...");
    button.setSize(new Dimension(100, 100));
    button.setVisible(true);
    buttonPanel.add(button,BorderLayout.CENTER);
    button.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        dispose();
      }

    });

    leftPanel.add(favoritesBrowserPane);
    leftPanel.add(buttonPanel);

    toolBar.setVisible(true);
    favoritesBrowserPane.goToURL(getClass().getResource("HelpPages/mainIndex.html"));


    JSplitPane splitPane=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
                                        new JScrollPane (leftPanel),
                                        new JScrollPane (browserPane));
    splitPane.setDividerLocation(300);
    splitPane.setOneTouchExpandable(true);

    Container contentPane=getContentPane();
    contentPane.add(toolBar,BorderLayout.NORTH);
    contentPane.add(splitPane,BorderLayout.CENTER);

    Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds(1,1,dimension.width-5, dimension.height-30);

  }
}