	package org.webdocwf.util.loader.wizard;

	import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.Writer;
import java.util.HashMap;

import javax.swing.AbstractAction;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingConstants;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;

	public class OctopusGeneratorPanel extends JPanel {

		private static final String SOURCE_TYPE = "Source database type",
			TARGET_TYPE = "Target database type",
			SOURCE_DATABASE = "Source database URL",
			TARGET_DATABASE = "Target database URL",
			SOURCE_USER = "Source database user",
			SOURCE_PASSWORD = "Source database password",
			TARGET_USER = "Target database user",
			TARGET_PASSWORD = "Target database password",
			VALUE_MODE = "Value mode",
			GENERATOR_OUTPUT = "Generator output directory",
			DOML_PATH = "Doml URL( when use Doml as input )",
			PACKAGE_NAME = "Package name",
			SOURCE_DRIVER_NAME = "Source database driver name",
			TARGET_DRIVER_NAME = "Target database driver name",
			ADDITIONAL_PATHS = "Additional classpath",
			DROP_TABLE = "Drop Tables",
			CREATE_TABLE = "Create Tables",
			CREATE_PRIMARY_KEYS = "Create Primary Keys",
			DROP_FOREIGN_KEYS = "Drop Foreign Keys",
			CREATE_FOREIGN_KEYS = "Create Foreign Keys",
			CREATE_INDEXES = "Create Indexes",
			CREATE_SQL_FOR_ALL_VENDORS = "Create SQL Statements for All Vendors",
			GENERATE_DOML = "Generate Doml file",
			GENERATE_XML = "Generate Xml files",
			GENERATE_SQL = "Generate Sql files",
			OPTIMIZED_MODE = "Optimized mode for all tables",
			FULL_MODE = "Full mode for all tables",
			INCLUDE_TABLE_LIST = "Include Table List (e.g. table1;table2)",
			PATH_TO_CONF_IN_JAR = "Path to conf files in jar",
			LOG_MODE = "Log mode",
			LOG_FILE_NAME ="Log file name",
			LOG_FILE_DIRECTORY = "Log file directory";

		//dimensions
		public static Dimension bigButton = new Dimension(140, 25);
		public static Dimension toolBarButton = new Dimension(30, 30);
		public static Dimension smallComponent = new Dimension(150, 20);
		public static Dimension bigComponent = new Dimension(400, 20);
		public static Dimension bigPlusButton = new Dimension(380, 20);
		public static Dimension veryBigComponent = new Dimension(650, 20);
		public static Dimension veryBigPlusButton = new Dimension(630, 20);
		public static Dimension panelComponenet = new Dimension(720, 40);

		JSplitPane main;

		Border loweredBorder = BorderFactory.createEtchedBorder(EtchedBorder.LOWERED);
		Border raisedBorder = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);
		Border bevelBorder = BorderFactory.createLoweredBevelBorder();

		private JCheckBox sqlFiles,
			xmlFiles,
			domlFile,
			createTables,
			createPK,
			createFK,
			createIn,
			dropTables,
			createSQLForAll,
			dropFK;
		private JRadioButton optimizedMode, fullMode;
		private JTextField packageField, generatorOutput, addPaths;
//		private OctopusProjectFrame parent;
		private OctopusGeneratorData initData;
		private HashMap fields;
		private JTextArea traceArea;

		public OctopusGeneratorPanel() {
			//    super("Octopus Generator Application", true, true, true, true);
			//	setFrameIcon( new ImageIcon(getClass().getClassLoader().getResource("org/webdocwf/util/loader/"+
			//		   "wizard/images/Enhydra16.gif")));

//			this.parent = parent;
			fields = new HashMap();
			//generatorOptions
			//    JPanel generatorOptionsUp = new JPanel();
//			JPanel generatorOptionsDown = new JPanel();

			//generator input data
			JTabbedPane octopusGeneratorData = new JTabbedPane();
			JPanel commonPanel = new JPanel();
			JPanel advancedPanel = new JPanel();
			JPanel outputOptions = new JPanel();
			octopusGeneratorData.addTab("JDBC", commonPanel);
			octopusGeneratorData.addTab("Output options", outputOptions);
			octopusGeneratorData.addTab("Advanced", advancedPanel);

			//generatotOptionsUp panel
			//    generatorOptionsUp.setLayout(new BoxLayout(generatorOptionsUp, BoxLayout.Y_AXIS));
			//    generatorOptionsUp.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
//			JButton help = createOctopusButton("Help", bigButton);
//			help.setAction(new OctopusHelpAction());
			//    generatorOptionsUp.add(help);

			//generatotOptionsDown panel
//			generatorOptionsDown.setLayout(new BoxLayout(generatorOptionsDown, BoxLayout.Y_AXIS));
//			generatorOptionsDown.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
//			JButton start = createOctopusButton("Start", bigButton);
//			start.setAction(new StartOctopusGenerator());
//			JButton stop = createOctopusButton("Stop", bigButton);
//			stop.setAction(new StopOctopusGenerator());
//			JButton save = createOctopusButton("Save", bigButton);
//			save.setAction(new SaveProjectAction());
//			generatorOptionsDown.add(Box.createRigidArea(new Dimension(0, 5)));
//			generatorOptionsDown.add(start);
//			generatorOptionsDown.add(Box.createRigidArea(new Dimension(0, 5)));
//			generatorOptionsDown.add(stop);
//			generatorOptionsDown.add(Box.createRigidArea(new Dimension(0, 5)));
//			generatorOptionsDown.add(save);
//			generatorOptionsDown.add(Box.createRigidArea(new Dimension(0, 15)));
//			generatorOptionsDown.add(help);

			//generatorOptions
			//    JSplitPane generatorOptions = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true,
			//        generatorOptionsUp, generatorOptionsDown);
			//    generatorOptions.setOneTouchExpandable(true);
			//    generatorOptions.setDividerLocation(560);

			//    JSplitPane generatorInputData = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true,
			//        generatorOptions, octopusGeneratorData);
//			JSplitPane generatorInputData =
//				new JSplitPane(
//					JSplitPane.HORIZONTAL_SPLIT,
//					true,
//					new JPanel(),
//					octopusGeneratorData);

			//advanced panel
			JPanel pathToConfPanel = new JPanel();
			pathToConfPanel.setLayout(new BoxLayout(pathToConfPanel, BoxLayout.X_AXIS));
			pathToConfPanel.setBorder(setTitleOfBorder("Advanced Options", loweredBorder));
			JLabel strPathToConf = OctopusProjectFrame.createOctopusLabel(PATH_TO_CONF_IN_JAR, smallComponent);
			JTextField pathToConf = OctopusProjectFrame.createOctopusTextField(PATH_TO_CONF_IN_JAR, veryBigComponent);
			pathToConfPanel.add(strPathToConf);
			pathToConfPanel.add(pathToConf);

			JPanel mainPathToConfPanel = new JPanel();
			mainPathToConfPanel.setLayout(new BoxLayout(mainPathToConfPanel, BoxLayout.X_AXIS));
			mainPathToConfPanel.add(pathToConfPanel);
			mainPathToConfPanel.add(Box.createHorizontalGlue());

			advancedPanel.setLayout(new BoxLayout(advancedPanel, BoxLayout.Y_AXIS));
			advancedPanel.add(Box.createRigidArea(new Dimension(0, 15)));
			advancedPanel.add(mainPathToConfPanel);

			//sourcePanel
			JPanel sourcePanel = new JPanel();
			sourcePanel.setLayout(new BoxLayout(sourcePanel, BoxLayout.Y_AXIS));
			//sourceType
			JLabel strSourceType = OctopusProjectFrame.createOctopusLabel(SOURCE_TYPE, bigComponent);
			JComboBox sourceType = OctopusProjectFrame.createOctopusCombobox(SOURCE_TYPE, bigComponent);
			//sourceUrl
			JLabel strSourceUrl = OctopusProjectFrame.createOctopusLabel(SOURCE_DATABASE, bigComponent);
			JTextField sourceUrl = OctopusProjectFrame.createOctopusTextField(SOURCE_DATABASE, bigComponent);
			//sourceDriverName
			JLabel strSourceDriverName = OctopusProjectFrame.createOctopusLabel(SOURCE_DRIVER_NAME, bigComponent);
			JComboBox sourceDriverName = OctopusProjectFrame.createOctopusCombobox(SOURCE_DRIVER_NAME, bigComponent);
			//sourceUser
			JLabel strSourceUser = OctopusProjectFrame.createOctopusLabel(SOURCE_USER, bigComponent);
			JTextField sourceUser = OctopusProjectFrame.createOctopusTextField(SOURCE_USER, bigComponent);
			//sourcePassword
			JLabel strSourcePassword = OctopusProjectFrame.createOctopusLabel(SOURCE_PASSWORD, bigComponent);
			JTextField sourcePassword = OctopusProjectFrame.createOctopusTextField(SOURCE_PASSWORD, bigComponent);
			//doml
			JLabel strDomlUrl = OctopusProjectFrame.createOctopusLabel(DOML_PATH, bigComponent);
			JTextField domlUrl = OctopusProjectFrame.createOctopusTextField(DOML_PATH, bigPlusButton);
			JButton domlButton = OctopusProjectFrame.createOctopusButton("doml url button", new Dimension(20, 20));
			domlButton.setAction(new BrowseAction_DOML());

			ImageIcon icon =
				new ImageIcon(
					getClass().getClassLoader().getResource(
						"org/webdocwf/util/loader/" + "wizard/images/database.gif"));
			JLabel sourceLabel = new JLabel("JDBC Source Database", icon, SwingConstants.RIGHT);

			sourcePanel.add(createJDBCRow(sourceLabel, null));
			sourcePanel.add(Box.createRigidArea(new Dimension(0, 10)));
			sourcePanel.add(createJDBCRow(strSourceType, null));
			sourcePanel.add(createJDBCRow(sourceType, null));
			sourcePanel.add(createJDBCRow(strSourceUrl, null));
			sourcePanel.add(createJDBCRow(sourceUrl, null));
			sourcePanel.add(createJDBCRow(strDomlUrl, null));
			sourcePanel.add(createJDBCRow(domlUrl, domlButton));
			sourcePanel.add(createJDBCRow(strSourceDriverName, null));
			sourcePanel.add(createJDBCRow(sourceDriverName, null));
			sourcePanel.add(createJDBCRow(strSourceUser, null));
			sourcePanel.add(createJDBCRow(sourceUser, null));
			sourcePanel.add(createJDBCRow(strSourcePassword, null));
			sourcePanel.add(createJDBCRow(sourcePassword, null));

			sourcePanel.setBorder(setTitleOfBorder("", bevelBorder));

			//targetPanel
			JPanel targetPanel = new JPanel();
			targetPanel.setLayout(new BoxLayout(targetPanel, BoxLayout.Y_AXIS));
			//targetType
			JLabel strTargetType = OctopusProjectFrame.createOctopusLabel(TARGET_TYPE, bigComponent);
			JComboBox targetType = OctopusProjectFrame.createOctopusCombobox(TARGET_TYPE, bigComponent);
			//targetUrl
			JLabel strTargetUrl =OctopusProjectFrame.createOctopusLabel(TARGET_DATABASE, bigComponent);
			JTextField targetUrl = OctopusProjectFrame.createOctopusTextField(TARGET_DATABASE, bigComponent);
			//targetDriverName
			JLabel strTargetDriverName = OctopusProjectFrame.createOctopusLabel(TARGET_DRIVER_NAME, bigComponent);
			JComboBox targetDriverName = OctopusProjectFrame.createOctopusCombobox(TARGET_DRIVER_NAME, bigComponent);
			//targetUser
			JLabel strTargetUser = OctopusProjectFrame.createOctopusLabel(TARGET_USER, bigComponent);
			JTextField targetUser = OctopusProjectFrame.createOctopusTextField(TARGET_USER, bigComponent);
			//targetPassword
			JLabel strTargetPassword = OctopusProjectFrame.createOctopusLabel(TARGET_PASSWORD, bigComponent);
			JTextField targetPassword = OctopusProjectFrame.createOctopusTextField(TARGET_PASSWORD, bigComponent);

			JLabel strTargetDoml = OctopusProjectFrame.createOctopusLabel("Doml URL", bigComponent);
			String msg = "Doml file will be placed in output directory";
			JTextField targetDoml = OctopusProjectFrame.createOctopusTextField("Doml URL target", bigComponent);
			targetDoml.setText(msg);
			targetDoml.setEditable(false);

			ImageIcon icon2 =
				new ImageIcon(
					getClass().getClassLoader().getResource(
						"org/webdocwf/util/loader/" + "wizard/images/database2.gif"));
			JLabel targetLabel = new JLabel("JDBC Target Database", icon2, SwingConstants.RIGHT);

			targetPanel.add(createJDBCRow(targetLabel, null));
			targetPanel.add(Box.createRigidArea(new Dimension(0, 10)));
			targetPanel.add(createJDBCRow(strTargetType, null));
			targetPanel.add(createJDBCRow(targetType, null));
			targetPanel.add(createJDBCRow(strTargetUrl, null));
			targetPanel.add(createJDBCRow(targetUrl, null));
			targetPanel.add(createJDBCRow(strTargetDoml, null));
			targetPanel.add(createJDBCRow(targetDoml, null));
			targetPanel.add(createJDBCRow(strTargetDriverName, null));
			targetPanel.add(createJDBCRow(targetDriverName, null));
			targetPanel.add(createJDBCRow(strTargetUser, null));
			targetPanel.add(createJDBCRow(targetUser, null));
			targetPanel.add(createJDBCRow(strTargetPassword, null));
			targetPanel.add(createJDBCRow(targetPassword, null));

			targetPanel.setBorder(setTitleOfBorder("", bevelBorder));

			JPanel JDBCPanel = new JPanel();
			JDBCPanel.setLayout(new BoxLayout(JDBCPanel, BoxLayout.X_AXIS));
			JDBCPanel.add(sourcePanel);
			JDBCPanel.add(targetPanel);

			JPanel JDBCMainPanel = new JPanel();
			JDBCMainPanel.setLayout(new BoxLayout(JDBCMainPanel, BoxLayout.X_AXIS));
			JDBCMainPanel.add(JDBCPanel);
			JDBCMainPanel.add(Box.createHorizontalGlue());

			//value mode panel
			JPanel valuModePanel = new JPanel();
			valuModePanel.setLayout(new BoxLayout(valuModePanel, BoxLayout.X_AXIS));
			valuModePanel.setBorder(setTitleOfBorder("Value mode", loweredBorder));
			JLabel strValueMode = OctopusProjectFrame.createOctopusLabel(VALUE_MODE, smallComponent);
			JComboBox valueMode = OctopusProjectFrame.createOctopusCombobox(VALUE_MODE, veryBigComponent);
			valuModePanel.add(strValueMode);
			valuModePanel.add(valueMode);

			JPanel mainValueModePanel = new JPanel();
			mainValueModePanel.setLayout(new BoxLayout(mainValueModePanel, BoxLayout.X_AXIS));
			mainValueModePanel.add(valuModePanel);
			mainValueModePanel.add(Box.createHorizontalGlue());

			//generatorOutput panel
			JPanel generatorOutputPanel = new JPanel();
			generatorOutputPanel.setLayout(new BoxLayout(generatorOutputPanel, BoxLayout.X_AXIS));
			JPanel generatorOutputInnerPanel = new JPanel();
			JButton browseGeneratorOutput = OctopusProjectFrame.createOctopusButton("O", new Dimension(20, 20));
			browseGeneratorOutput.setAction(new BrowseAction_GO());

			generatorOutputInnerPanel.setLayout(
				new BoxLayout(generatorOutputInnerPanel, BoxLayout.X_AXIS));
			generatorOutputInnerPanel.setBorder(
				setTitleOfBorder("Generator Output", loweredBorder));
			JLabel strGeneratorOutput = OctopusProjectFrame.createOctopusLabel(GENERATOR_OUTPUT, smallComponent);
			generatorOutput = OctopusProjectFrame.createOctopusTextField(GENERATOR_OUTPUT, veryBigPlusButton);
			generatorOutputInnerPanel.add(strGeneratorOutput);
			generatorOutputInnerPanel.add(generatorOutput);
			generatorOutputInnerPanel.add(browseGeneratorOutput);

			generatorOutputPanel.add(generatorOutputInnerPanel);
			generatorOutputPanel.add(Box.createHorizontalGlue());

			//includetablelist panel
			JPanel includeTableListPanel = new JPanel();
			includeTableListPanel.setLayout(new BoxLayout(includeTableListPanel, BoxLayout.X_AXIS));
			JPanel includeTableListInnerPanel = new JPanel();
			includeTableListInnerPanel.setLayout(
				new BoxLayout(includeTableListInnerPanel, BoxLayout.X_AXIS));
			includeTableListInnerPanel.setBorder(setTitleOfBorder("Tables List", loweredBorder));
			JLabel strIncludeTableList = OctopusProjectFrame.createOctopusLabel(INCLUDE_TABLE_LIST, smallComponent);
			JTextField includeTableList =
			OctopusProjectFrame.createOctopusTextField(INCLUDE_TABLE_LIST, veryBigComponent);
			includeTableListInnerPanel.add(strIncludeTableList);
			includeTableListInnerPanel.add(includeTableList);

			includeTableListPanel.add(includeTableListInnerPanel);
			includeTableListPanel.add(Box.createHorizontalGlue());

			//additinal classpaths panel
			JPanel addPathsPanel = new JPanel();
			addPathsPanel.setLayout(new BoxLayout(addPathsPanel, BoxLayout.X_AXIS));
			JPanel addPathsInnerPanel = new JPanel();
			JButton browseAdditionalClass = OctopusProjectFrame.createOctopusButton("O", new Dimension(20, 20));
			browseAdditionalClass.setAction(new BrowseAction_AC());
			addPathsInnerPanel.setLayout(new BoxLayout(addPathsInnerPanel, BoxLayout.X_AXIS));
			addPathsInnerPanel.setBorder(setTitleOfBorder("Add new drivers", loweredBorder));
			JLabel strAddPaths = OctopusProjectFrame.createOctopusLabel(ADDITIONAL_PATHS, smallComponent);
			addPaths = OctopusProjectFrame.createOctopusTextField(ADDITIONAL_PATHS, veryBigPlusButton);
			addPathsInnerPanel.add(strAddPaths);
			addPathsInnerPanel.add(addPaths);
			addPathsInnerPanel.add(browseAdditionalClass);

			addPathsPanel.add(addPathsInnerPanel);
			addPathsPanel.add(Box.createHorizontalGlue());

			JPanel commonOptionsPanel = new JPanel();
			JPanel commonOptionsMainPanel = new JPanel();
			commonOptionsPanel.setLayout(new BoxLayout(commonOptionsPanel, BoxLayout.Y_AXIS));
			commonOptionsMainPanel.setLayout(
				new BoxLayout(commonOptionsMainPanel, BoxLayout.X_AXIS));
			commonOptionsPanel.add(mainValueModePanel);
			commonOptionsPanel.add(generatorOutputPanel);
			commonOptionsPanel.add(includeTableListPanel);
			commonOptionsPanel.add(addPathsPanel);

			commonOptionsMainPanel.add(commonOptionsPanel);
			commonOptionsMainPanel.add(Box.createHorizontalGlue());

			commonPanel.setLayout(new BoxLayout(commonPanel, BoxLayout.Y_AXIS));
			commonPanel.add(JDBCMainPanel);
			commonPanel.add(commonOptionsMainPanel);
			commonPanel.add(Box.createVerticalGlue());

			JPanel outputMode = new JPanel();
			outputMode.setLayout(new BoxLayout(outputMode, BoxLayout.X_AXIS));
			outputMode.setBorder(setTitleOfBorder("Output Mode", loweredBorder));
			sqlFiles = new JCheckBox(GENERATE_SQL);
			sqlFiles.setSelected(true);
			xmlFiles = new JCheckBox(GENERATE_XML);
			xmlFiles.setSelected(true);
			domlFile = new JCheckBox(GENERATE_DOML);
			outputMode.add(sqlFiles);
			outputMode.add(xmlFiles);
			outputMode.add(domlFile);

			sqlFiles.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (sqlFiles.isSelected()) {
						createTables.setEnabled(true);
						createTables.setSelected(true);
						dropTables.setEnabled(true);
						dropTables.setSelected(true);
						createPK.setEnabled(true);
						createPK.setSelected(true);
						createFK.setEnabled(true);
						createFK.setSelected(true);
						dropFK.setEnabled(true);
						dropFK.setSelected(true);
						createIn.setEnabled(true);
						createIn.setSelected(true);
						createSQLForAll.setEnabled(true);
						createSQLForAll.setSelected(false);
					} else {
						createTables.setSelected(false);
						createTables.setEnabled(false);
						dropTables.setEnabled(false);
						dropTables.setSelected(false);
						createPK.setEnabled(false);
						createPK.setSelected(false);
						createFK.setEnabled(false);
						createFK.setSelected(false);
						dropFK.setEnabled(false);
						dropFK.setSelected(false);
						createIn.setEnabled(false);
						createIn.setSelected(false);
						createSQLForAll.setEnabled(false);
						createSQLForAll.setSelected(false);
					}
				}
			});

			xmlFiles.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (xmlFiles.isSelected()) {
						optimizedMode.setEnabled(true);
						optimizedMode.setSelected(false);
						fullMode.setEnabled(true);
						fullMode.setSelected(true);
					} else {
						optimizedMode.setEnabled(false);
						optimizedMode.setSelected(false);
						fullMode.setEnabled(false);
						fullMode.setSelected(false);
					}
				}
			});

			domlFile.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (domlFile.isSelected()) {
						packageField.setEditable(true);
						packageField.setText("");
					} else {
						packageField.setText("");
						packageField.setEditable(false);

					}
				}
			});

			JPanel mainOutputMode = new JPanel();
			mainOutputMode.setLayout(new BoxLayout(mainOutputMode, BoxLayout.X_AXIS));
			mainOutputMode.add(outputMode);
			mainOutputMode.add(Box.createHorizontalGlue());

			createTables = new JCheckBox(CREATE_TABLE);
			createTables.setSelected(true);
			createPK = new JCheckBox(CREATE_PRIMARY_KEYS);
			createPK.setSelected(true);
			createFK = new JCheckBox(CREATE_FOREIGN_KEYS);
			createFK.setSelected(true);
			createIn = new JCheckBox(CREATE_INDEXES);
			createIn.setSelected(true);
			dropTables = new JCheckBox(DROP_TABLE);
			dropTables.setSelected(true);
			dropFK = new JCheckBox(DROP_FOREIGN_KEYS);
			dropFK.setSelected(true);
			createSQLForAll = new JCheckBox(CREATE_SQL_FOR_ALL_VENDORS);

			JPanel sqlOptionsPanel1 = new JPanel();
			sqlOptionsPanel1.setLayout(new BoxLayout(sqlOptionsPanel1, BoxLayout.Y_AXIS));
			sqlOptionsPanel1.add(dropTables);
			sqlOptionsPanel1.add(createTables);
			sqlOptionsPanel1.add(createPK);

			JPanel sqlOptionsPanel2 = new JPanel();
			sqlOptionsPanel2.setLayout(new BoxLayout(sqlOptionsPanel2, BoxLayout.Y_AXIS));
			sqlOptionsPanel2.add(dropFK);
			sqlOptionsPanel2.add(createFK);
			sqlOptionsPanel2.add(createIn);

			JPanel sqlOptionsPanel3 = new JPanel();
			sqlOptionsPanel3.setLayout(new BoxLayout(sqlOptionsPanel3, BoxLayout.Y_AXIS));
			sqlOptionsPanel3.add(createSQLForAll);

			JPanel sqlOptionsPanel = new JPanel();
			sqlOptionsPanel.setLayout(new BoxLayout(sqlOptionsPanel, BoxLayout.X_AXIS));
			sqlOptionsPanel.setBorder(setTitleOfBorder("SQL Options", loweredBorder));
			sqlOptionsPanel.add(sqlOptionsPanel1);
			sqlOptionsPanel.add(sqlOptionsPanel2);
			sqlOptionsPanel.add(sqlOptionsPanel3);

			JPanel mainSqlOptionsPanel = new JPanel();
			mainSqlOptionsPanel.setLayout(new BoxLayout(mainSqlOptionsPanel, BoxLayout.X_AXIS));
			mainSqlOptionsPanel.add(sqlOptionsPanel);
			mainSqlOptionsPanel.add(Box.createHorizontalGlue());

			JPanel xmlOptionsPanel = new JPanel();
			xmlOptionsPanel.setLayout(new BoxLayout(xmlOptionsPanel, BoxLayout.X_AXIS));
			optimizedMode = new JRadioButton(OPTIMIZED_MODE);
			fullMode = new JRadioButton(FULL_MODE);
//			fullMode.setSelected(true);

			optimizedMode.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (optimizedMode.isSelected()) {
						fullMode.setSelected(false);
					} else {
						fullMode.setSelected(true);
					}
				}
			});

			fullMode.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (fullMode.isSelected()) {
						optimizedMode.setSelected(false);
					} else {
						optimizedMode.setSelected(true);
					}
				}
			});

			xmlOptionsPanel.setBorder(setTitleOfBorder("XML Options", loweredBorder));
			xmlOptionsPanel.add(optimizedMode);
			xmlOptionsPanel.add(fullMode);

			JPanel mainXmlOptionsPanel = new JPanel();
			mainXmlOptionsPanel.setLayout(new BoxLayout(mainXmlOptionsPanel, BoxLayout.X_AXIS));
			mainXmlOptionsPanel.add(xmlOptionsPanel);
			mainXmlOptionsPanel.add(Box.createHorizontalGlue());

			JPanel packagePanel = new JPanel();
			packagePanel.setLayout(new BoxLayout(packagePanel, BoxLayout.X_AXIS));
			packagePanel.setBorder(setTitleOfBorder("Package name for doml file", loweredBorder));
			packageField = OctopusProjectFrame.createOctopusTextField(PACKAGE_NAME, veryBigComponent);
			packageField.setEditable(false);
			JLabel strPackageField = OctopusProjectFrame.createOctopusLabel(PACKAGE_NAME, smallComponent);
			packagePanel.add(strPackageField);
			packagePanel.add(packageField);

			JPanel mainPackagePanel = new JPanel();
			mainPackagePanel.setLayout(new BoxLayout(mainPackagePanel, BoxLayout.X_AXIS));
			mainPackagePanel.add(packagePanel);
			mainPackagePanel.add(Box.createHorizontalGlue());
			
			
			//zk added this for logging
			JPanel loggingModePanel = new JPanel();
			loggingModePanel.setLayout(new BoxLayout(loggingModePanel, BoxLayout.X_AXIS));
			
			
			//log mode
			JLabel strLogMode = OctopusProjectFrame.createOctopusLabel(LOG_MODE, smallComponent);
			JComboBox logMode = OctopusProjectFrame.createOctopusCombobox(LOG_MODE, veryBigComponent);
			
			loggingModePanel.add(strLogMode);
			loggingModePanel.add(logMode);
			//loggingModePanel.add(Box.createHorizontalGlue());
			
			//log file directory
			JPanel loggingDirPanel = new JPanel();
			loggingDirPanel.setLayout(new BoxLayout(loggingDirPanel, BoxLayout.X_AXIS));
			JLabel strLogFileDir = OctopusProjectFrame.createOctopusLabel(LOG_FILE_DIRECTORY, smallComponent);
			JTextField logFileDir = OctopusProjectFrame.createOctopusTextField(LOG_FILE_DIRECTORY, veryBigPlusButton);
			JButton logDirButton = OctopusProjectFrame.createOctopusButton("", new Dimension(20, 20));
		
			logDirButton.setAction(new BrowseAction_L());
			
			loggingDirPanel.add(strLogFileDir);
			loggingDirPanel.add(logFileDir);
			loggingDirPanel.add(logDirButton);
			//loggingDirPanel.add(Box.createHorizontalGlue());
			
			//log file name
			JPanel loggingFilePanel = new JPanel();
			loggingFilePanel.setLayout(new BoxLayout(loggingFilePanel, BoxLayout.X_AXIS));
			JLabel strLogFileName = OctopusProjectFrame.createOctopusLabel(LOG_FILE_NAME, smallComponent);
			JTextField logFileName = OctopusProjectFrame.createOctopusTextField(LOG_FILE_NAME, veryBigComponent); 
			
			loggingFilePanel.add(strLogFileName);
			loggingFilePanel.add(logFileName);
			//loggingFilePanel.add(Box.createHorizontalGlue());
			
			
			JPanel loggingPanel = new JPanel();
			loggingPanel.setLayout(new BoxLayout(loggingPanel, BoxLayout.Y_AXIS));
			loggingPanel.setBorder(setTitleOfBorder("Logging options", loweredBorder));
			loggingPanel.add(loggingModePanel);
			loggingPanel.add(loggingDirPanel);
			loggingPanel.add(loggingFilePanel);
			//loggingPanel.add(Box.createHorizontalGlue());
						
			JPanel mainLoggingPanel = new JPanel();
			mainLoggingPanel.setLayout(new BoxLayout(mainLoggingPanel, BoxLayout.X_AXIS));
			mainLoggingPanel.add(loggingPanel);
			//mainLoggingPanel.setAlignmentX(0);
			mainLoggingPanel.add(Box.createHorizontalGlue());
		
			//end
			
			
		
			//output options panel
			outputOptions.setLayout(new BoxLayout(outputOptions, BoxLayout.Y_AXIS));

			outputOptions.add(Box.createRigidArea(new Dimension(0, 10)));
			outputOptions.add(mainOutputMode);
			outputOptions.add(Box.createRigidArea(new Dimension(0, 10)));
			outputOptions.add(mainSqlOptionsPanel);
			outputOptions.add(Box.createRigidArea(new Dimension(0, 10)));
			outputOptions.add(mainXmlOptionsPanel);
			outputOptions.add(Box.createRigidArea(new Dimension(0, 10)));
			outputOptions.add(mainPackagePanel);
			//zk added for logging
			outputOptions.add(Box.createRigidArea(new Dimension(0, 10)));
			outputOptions.add(mainLoggingPanel);
			
			//


			// output panel
			JPanel textAreaPanel = new JPanel();
			textAreaPanel.setLayout(new BoxLayout(textAreaPanel, BoxLayout.X_AXIS));
			JPanel areaOptionPanel = new JPanel();
			areaOptionPanel.setLayout(new BoxLayout(areaOptionPanel, BoxLayout.Y_AXIS));
			traceArea = new JTextArea(18, 130);
			traceArea.setLineWrap(true);
			traceArea.setEditable(false);
			traceArea.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
			JScrollPane scrollPane =
				new JScrollPane(
					traceArea,
					ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
					ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

			scrollPane.setBorder(
				setTitleOfBorder("Log Octopus Generator output ... ", loweredBorder));
			JButton fullScreen = OctopusProjectFrame.createOctopusButton("Full Screen", new Dimension(25, 25));
			fullScreen.setAction(new FullScreenAction());
			JButton normalScreen = OctopusProjectFrame.createOctopusButton("Normal Screen", new Dimension(25, 25));
			normalScreen.setAction(new NormalScreenAction());
			JButton saveScreen = OctopusProjectFrame.createOctopusButton("Save Trace", new Dimension(25, 25));
			saveScreen.setAction(new SaveTraceAction());
			JButton clearTrace = OctopusProjectFrame.createOctopusButton("Clear Trace", new Dimension(25, 25));
			clearTrace.setAction(new ClearTraceAction());

			areaOptionPanel.add(fullScreen);
			areaOptionPanel.add(normalScreen);
			areaOptionPanel.add(saveScreen);
			areaOptionPanel.add(clearTrace);
			areaOptionPanel.add(Box.createVerticalGlue());
			areaOptionPanel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));

//			JPanel areaOptionMainPanel = new JPanel(new BorderLayout());
//			areaOptionMainPanel.add(areaOptionPanel, BorderLayout.PAGE_START);

			textAreaPanel.add(areaOptionPanel);
			textAreaPanel.add(scrollPane);
//			main =
//				new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, generatorInputData, textAreaPanel);
			main = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, octopusGeneratorData, textAreaPanel);
			main.setOneTouchExpandable(true);
			//    main.setDividerLocation(650);

			//setting all parameters into hash table
			//source
			fields.put(SOURCE_TYPE, sourceType);
			fields.put(SOURCE_DATABASE, sourceUrl);
			fields.put(DOML_PATH, domlUrl);
			fields.put(SOURCE_DRIVER_NAME, sourceDriverName);
			fields.put(SOURCE_USER, sourceUser);
			fields.put(SOURCE_PASSWORD, sourcePassword);
			//target
			fields.put(TARGET_TYPE, targetType);
			fields.put(TARGET_DATABASE, targetUrl);
			fields.put(TARGET_DRIVER_NAME, targetDriverName);
			fields.put(TARGET_USER, targetUser);
			fields.put(TARGET_PASSWORD, targetPassword);

			//copy mode
			fields.put(VALUE_MODE, valueMode);

			fields.put(GENERATOR_OUTPUT, generatorOutput);
			fields.put(ADDITIONAL_PATHS, addPaths);
			fields.put(INCLUDE_TABLE_LIST, includeTableList);

			//sql statements
			fields.put(GENERATE_SQL, sqlFiles);
			fields.put(CREATE_TABLE, createTables);
			fields.put(CREATE_PRIMARY_KEYS, createPK);
			fields.put(CREATE_FOREIGN_KEYS, createFK);
			fields.put(CREATE_INDEXES, createIn);
			fields.put(DROP_TABLE, dropTables);
			fields.put(DROP_FOREIGN_KEYS, dropFK);
			fields.put(CREATE_SQL_FOR_ALL_VENDORS, createSQLForAll);

			//xml options
			fields.put(GENERATE_XML, xmlFiles);
			fields.put(FULL_MODE, fullMode);
			fields.put(OPTIMIZED_MODE, optimizedMode);
			
			//ZK added for logging
			fields.put(LOG_MODE, logMode);
			fields.put(LOG_FILE_NAME, logFileName);
			fields.put(LOG_FILE_DIRECTORY, logFileDir);
			//end
			
			//doml options
			fields.put(GENERATE_DOML, domlFile);
			fields.put(PACKAGE_NAME, packageField);

			//advanced
			fields.put(PATH_TO_CONF_IN_JAR, pathToConf);

			//    Container container = getContentPane();
			setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
			add(main);
			setBounds(0, 0, 970, 680);
		}

		private JPanel createJDBCRow(JComponent jc1, JComponent jc2) {
			JPanel jp = new JPanel();
			jp.setLayout(new BoxLayout(jp, BoxLayout.X_AXIS));
			jp.add(jc1);
			if (jc2 != null)
				jp.add(jc2);

			jp.add(Box.createHorizontalGlue());
			return jp;
		}

		private Border setTitleOfBorder(String title, Border border) {
			Border inb = BorderFactory.createTitledBorder(border, title);
			return inb;
		}
		
		public JTextArea getTraceArea() {
			return this.traceArea;
		}

//		private JButton createOctopusButton(String componentName, Dimension dimension) {
//
//			JButton button = new JButton();
//			if (!componentName.equalsIgnoreCase(""))
//				button.setText(componentName);
//
//			button.setAlignmentX(Component.LEFT_ALIGNMENT);
//			button.setAlignmentY(Component.CENTER_ALIGNMENT);
//			button.setMinimumSize(new Dimension(dimension));
//			button.setMaximumSize(new Dimension(dimension));
//			button.setPreferredSize(new Dimension(dimension));
//
//			return button;
//		}
//
//		private JComboBox createOctopusCombobox(String componentName, Dimension dimension) {
//
//			JComboBox comboBox = new JComboBox();
//			comboBox.setName(componentName);
//			comboBox.setAlignmentX(Component.LEFT_ALIGNMENT);
//			comboBox.setAlignmentY(Component.CENTER_ALIGNMENT);
//			comboBox.setMinimumSize(new Dimension(dimension));
//			comboBox.setMaximumSize(new Dimension(dimension));
//			comboBox.setPreferredSize(new Dimension(dimension));
//
//			return comboBox;
//		}
//
//		private JLabel createOctopusLabel(String componentName, Dimension dimension) {
//
//			JLabel label = new JLabel();
//			label.setText(componentName);
//			label.setAlignmentX(Component.LEFT_ALIGNMENT);
//			label.setAlignmentY(Component.CENTER_ALIGNMENT);
//			label.setMinimumSize(new Dimension(dimension));
//			label.setMaximumSize(new Dimension(dimension));
//			label.setPreferredSize(new Dimension(dimension));
//
//			return label;
//		}
//
//		private JTextField createOctopusTextField(String componentName, Dimension dimension) {
//
//			JTextField textField = new JTextField();
//			textField.setName(componentName);
//			textField.setAlignmentX(Component.LEFT_ALIGNMENT);
//			textField.setAlignmentY(Component.CENTER_ALIGNMENT);
//			textField.setMinimumSize(new Dimension(dimension));
//			textField.setMaximumSize(new Dimension(dimension));
//			textField.setPreferredSize(new Dimension(dimension));
//
//			return textField;
//		}

		public void setOctopusGeneratorInit(
			OctopusGeneratorData initData,
			String confJarStructure) {
			this.initData = initData;
			setField(LOG_MODE, initData.getLogMode(), "box");
			setField(LOG_FILE_DIRECTORY, initData.getLogFileDir(), "label");
			setField(LOG_FILE_NAME, initData.getLogFileName(), "label");
			
			setField(SOURCE_TYPE, initData.getSourceType(), "box");
			setField(TARGET_TYPE, initData.getTargetType(), "box");
			setField(SOURCE_DATABASE, initData.getSourceDatabase(), "label");
			setField(TARGET_DATABASE, initData.getTargetDatabase(), "label");
			setField(SOURCE_USER, initData.getSourceUser(), "label");
			setField(SOURCE_PASSWORD, initData.getSourcePassword(), "label");
			setField(TARGET_USER, initData.getTargetUser(), "label");
			setField(TARGET_PASSWORD, initData.getTargetPassword(), "label");
			setField(VALUE_MODE, initData.getValueMode(), "box");
			setField(GENERATOR_OUTPUT, initData.getGeneratorOutput(), "label");
			setField(DOML_PATH, initData.getDomlPath(), "label");
			setField(PACKAGE_NAME, initData.getPackageName(), "label");
			setField(SOURCE_DRIVER_NAME, initData.getSourceDriverName(), "box");
			setField(TARGET_DRIVER_NAME, initData.getTargetDriverName(), "box");
			setField(ADDITIONAL_PATHS, initData.getAdditionalPaths(), "label");
			setField(DROP_TABLE, initData.getSqlStmtDropTable(), "checkBox");
			setField(DROP_FOREIGN_KEYS, initData.getSqlStmtDropIntegrity(), "checkBox");
			setField(DROP_FOREIGN_KEYS, initData.getSqlStmtDropIntegrity(), "checkBox");
			setField(CREATE_TABLE, initData.getSqlStmtCreateTable(), "checkBox");
			setField(CREATE_PRIMARY_KEYS, initData.getSqlStmtCreatePK(), "checkBox");
			setField(CREATE_FOREIGN_KEYS, initData.getSqlStmtCreateFK(), "checkBox");
			setField(CREATE_INDEXES, initData.getSqlStmtCreateIndex(), "checkBox");
			setField(CREATE_SQL_FOR_ALL_VENDORS, initData.getSqlStmtForAllVendors(), "checkBox");
			setField(GENERATE_SQL, initData.getSqlGenerate(), "checkBox");
			setField(GENERATE_XML, initData.getXmlGenerate(), "checkBox");
			setField(GENERATE_DOML, initData.getDomlGenerate(), "checkBox");
			setField(FULL_MODE, initData.getFullMode(), "radioButton");
			setField(OPTIMIZED_MODE, initData.getFullMode().equalsIgnoreCase("true") ? "false" : "true", "radioButton");
			setField(INCLUDE_TABLE_LIST, initData.getIncludeTableList(), "label");
			setField(PATH_TO_CONF_IN_JAR, initData.getConfJarStructure(), "label");

		}

		public OctopusGeneratorData getOctopusGeneratorInit() throws Exception {
			initData.setLogMode(getField(LOG_MODE, "box"));
			initData.setLogFileName(getField(LOG_FILE_NAME, "label"));
			initData.setLogFileDir(getField(LOG_FILE_DIRECTORY, "label"));
			
			initData.setSourceType(getField(SOURCE_TYPE, "box"));
			initData.setTargetType(getField(TARGET_TYPE, "box"));
			initData.setSourceDatabase(getField(SOURCE_DATABASE, "label"));
			initData.setTargetDatabase(getField(TARGET_DATABASE, "label"));
			initData.setSourceUser(getField(SOURCE_USER, "label"));
			initData.setSourcePassword(getField(SOURCE_PASSWORD, "label"));
			initData.setTargetUser(getField(TARGET_USER, "label"));
			initData.setTargetPassword(getField(TARGET_PASSWORD, "label"));
			initData.setValueMode(getField(VALUE_MODE, "box"));
			initData.setGeneratorOutput(getField(GENERATOR_OUTPUT, "label"));
			initData.setDomlPath(getField(DOML_PATH, "label"));
			initData.setPackageName(getField(PACKAGE_NAME, "label"));
			initData.setSourceDriverName(getField(SOURCE_DRIVER_NAME, "box"));
			initData.setTargetDriverName(getField(TARGET_DRIVER_NAME, "box"));
			initData.setAdditionalPaths(getField(ADDITIONAL_PATHS, "label"));
			initData.setSqlStmtDropTable(getField(DROP_TABLE, "checkBox"));
			initData.setSqlStmtDropIntegrity(getField(DROP_FOREIGN_KEYS, "checkBox"));
			initData.setSqlStmtCreateTable(getField(CREATE_TABLE, "checkBox"));
			initData.setSqlStmtCreatePK(getField(CREATE_PRIMARY_KEYS, "checkBox"));
			initData.setSqlStmtCreateFK(getField(CREATE_FOREIGN_KEYS, "checkBox"));
			initData.setSqlStmtCreateIndex(getField(CREATE_INDEXES, "checkBox"));
			initData.setSqlStmtForAllVendors(getField(CREATE_SQL_FOR_ALL_VENDORS, "checkBox"));
			initData.setSqlGenerate(getField(GENERATE_SQL, "checkBox"));
			initData.setXmlGenerate(getField(GENERATE_XML, "checkBox"));
			initData.setDomlGenerate(getField(GENERATE_DOML, "checkBox"));
			if (getField(FULL_MODE, "radioButton").equalsIgnoreCase("true"))
				initData.setFullMode("true");
			else
				initData.setFullMode("false");
			initData.setIncludeTableList(getField(INCLUDE_TABLE_LIST, "label"));
			initData.setConfJarStructure(getField(PATH_TO_CONF_IN_JAR, "label"));

			return initData;
		}

		private String getField(String fieldName, String type) {
			if (type.equalsIgnoreCase("textfield") || type.equalsIgnoreCase("label")) {
				JTextField field = (JTextField) fields.get(fieldName);
				return field.getText().trim();
			} 
			else
				if (type.startsWith("checkBox")) {
					JCheckBox field = (JCheckBox) fields.get(fieldName);
					if (field.isSelected() == true)
						return "true";
					else
						return "false";
				}else
					if (type.startsWith("radioButton")) {
						JRadioButton field = (JRadioButton) fields.get(fieldName);
						if (field.isSelected() == true)
							return "true";
						else
							return "false";
					} else {
						JComboBox field = (JComboBox) fields.get(fieldName);
						return field.getSelectedItem().toString();

					}
		}

		private void setField(String fieldName, String value, String type) {
			if (type.equalsIgnoreCase("textfield") || type.equalsIgnoreCase("label")) {
				JTextField field = (JTextField) fields.get(fieldName);
				field.setText(value);
			} else
				if (type.equalsIgnoreCase("box")) {
					JComboBox field = (JComboBox) fields.get(fieldName);
					int itemCount = field.getItemCount();
					if (fieldName.equalsIgnoreCase(SOURCE_TYPE)) {
						for (int i = 0;
							i < OctopusGeneratorData.getSourceDatabaseTypes().length;
							i++) {
							if( itemCount != OctopusGeneratorData.getSourceDatabaseTypes().length )
								field.addItem(OctopusGeneratorData.getSourceDatabaseTypes()[i]);
							if (value
								.equalsIgnoreCase(OctopusGeneratorData.getSourceDatabaseTypes()[i]))
								field.setSelectedIndex(i);
						}
					} else
						if (fieldName.equalsIgnoreCase(TARGET_TYPE)) {
							for (int i = 0;
								i < OctopusGeneratorData.getTargetDatabaseTypes().length;
								i++) {
								if( itemCount != OctopusGeneratorData.getTargetDatabaseTypes().length )
									field.addItem(OctopusGeneratorData.getTargetDatabaseTypes()[i]);
								if (value
									.equalsIgnoreCase(
										OctopusGeneratorData.getTargetDatabaseTypes()[i]))
									field.setSelectedIndex(i);
							}
						} else
							if (fieldName.equalsIgnoreCase(SOURCE_DRIVER_NAME)) {
								for (int i = 0;
									i < OctopusGeneratorData.getSourceDriverNames().length;
									i++) {
									if( itemCount != OctopusGeneratorData.getSourceDriverNames().length )
										field.addItem(OctopusGeneratorData.getSourceDriverNames()[i]);
									if (value
										.equalsIgnoreCase(
											OctopusGeneratorData.getSourceDriverNames()[i]))
										field.setSelectedIndex(i);
								}
							} else
								if (fieldName.equalsIgnoreCase(TARGET_DRIVER_NAME)) {
									for (int i = 0;
										i < OctopusGeneratorData.getTargetDriverNames().length;
										i++) {
										if( itemCount != OctopusGeneratorData.getTargetDriverNames().length )
										field.addItem(
											OctopusGeneratorData.getTargetDriverNames()[i]);
										if (value
											.equalsIgnoreCase(
												OctopusGeneratorData.getTargetDriverNames()[i]))
											field.setSelectedIndex(i);
									}
								} else
									if (fieldName.equalsIgnoreCase(VALUE_MODE)) {
										for (int i = 0;
											i < OctopusGeneratorData.getValueModes().length;
											i++) {
											if( itemCount != OctopusGeneratorData.getValueModes().length )
												field.addItem(OctopusGeneratorData.getValueModes()[i]);
											if (value
												.equalsIgnoreCase(
													OctopusGeneratorData.getValueModes()[i]))
												field.setSelectedIndex(i);
										}
									}else 
										if (fieldName.equalsIgnoreCase(LOG_MODE)){
													boolean setted = false;
												  for(int i = 0; i < OctopusLoaderData.getLogModes().length; i++) {
													  if( field.getItemCount() != OctopusGeneratorData.getLogModes().length ) 
																field.addItem(OctopusGeneratorData.getLogModes()[i]);
																if( value.equalsIgnoreCase(OctopusGeneratorData.getLogModes()[i])) {
																	field.setSelectedIndex(i);
																	setted = true;
																}
												  }
														if(!setted)
																field.setSelectedIndex(1);
										}
				} else
					if (type.equalsIgnoreCase("checkbox")) {
						JCheckBox field = (JCheckBox) fields.get(fieldName);
						if (fieldName.equalsIgnoreCase(DROP_TABLE)) {
							if (value.equalsIgnoreCase("true"))
								field.setSelected(true);
							else
								field.setSelected(false);
						} else
							if (fieldName.equalsIgnoreCase(DROP_FOREIGN_KEYS)) {
								if (value.equalsIgnoreCase("true"))
									field.setSelected(true);
								else
									field.setSelected(false);
							} else
								if (fieldName.equalsIgnoreCase(CREATE_TABLE)) {
									if (value.equalsIgnoreCase("true"))
										field.setSelected(true);
									else
										field.setSelected(false);
								} else
									if (fieldName.equalsIgnoreCase(CREATE_PRIMARY_KEYS)) {
										if (value.equalsIgnoreCase("true"))
											field.setSelected(true);
										else
											field.setSelected(false);	
									} else
										if (fieldName.equalsIgnoreCase(CREATE_FOREIGN_KEYS)) {
											if (value.equalsIgnoreCase("true"))
												field.setSelected(true);
											else
												field.setSelected(false);
										} else
											if (fieldName.equalsIgnoreCase(CREATE_INDEXES)) {
												if (value.equalsIgnoreCase("true"))
													field.setSelected(true);
												else
													field.setSelected(false);
											} else
												if (fieldName
													.equalsIgnoreCase(CREATE_SQL_FOR_ALL_VENDORS)) {
													if (value.equalsIgnoreCase("true"))
														field.setSelected(true);
													else
														field.setSelected(false);
												} else
													if (fieldName
														.equalsIgnoreCase(GENERATE_SQL)) {
														if (value.equalsIgnoreCase("true"))
															field.setSelected(true);
														else
															field.setSelected(false);
													} else
														if (fieldName
															.equalsIgnoreCase(GENERATE_XML)) {
															if (value.equalsIgnoreCase("true"))
																field.setSelected(true);
															else
																field.setSelected(false);
														} else
															if (fieldName
																.equalsIgnoreCase(GENERATE_DOML)) {
																if (value.equalsIgnoreCase("true"))
																	field.setSelected(true);
																else
																	field.setSelected(false);
															}
					} else 
						if (type.equalsIgnoreCase("radioButton")) {
							JRadioButton field = (JRadioButton) fields.get(fieldName);
							if (value.equalsIgnoreCase("true"))
								field.setSelected(true);
							else
								field.setSelected(false); 		
					}
					
		}

		private class FullScreenAction extends AbstractAction {

			/**
			 * This method starts the LoaderGenerator application
			 */
			public FullScreenAction() {

				putValue(
					SMALL_ICON,
					new ImageIcon(
						getClass().getClassLoader().getResource(
							"org/webdocwf/util/loader/" + "wizard/images/Host16.gif")));
				putValue(SHORT_DESCRIPTION, "Full Screen");
				putValue(LONG_DESCRIPTION, "Set Trace to Full Screen");
				putValue(
					ACCELERATOR_KEY,
					KeyStroke.getKeyStroke(
						'F',
						Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
				putValue(MNEMONIC_KEY, new Integer('F'));
			}

			/**
			 * This method check if the action is performed (event key pressed)
			 * @param e is event
			 */
			public void actionPerformed(ActionEvent e) {
				main.setDividerLocation(0);
			}
		}
		
		

		private class NormalScreenAction extends AbstractAction {

			/**
			 * This method starts the LoaderGenerator application
			 */
			public NormalScreenAction() {

				putValue(
					SMALL_ICON,
					new ImageIcon(
						getClass().getClassLoader().getResource(
							"org/webdocwf/util/loader/" + "wizard/images/Unhost16.gif")));
				putValue(SHORT_DESCRIPTION, "Normal Screen");
				putValue(LONG_DESCRIPTION, "Back to normal screen");
				putValue(
					ACCELERATOR_KEY,
					KeyStroke.getKeyStroke(
						'N',
						Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
				putValue(MNEMONIC_KEY, new Integer('N'));
			}

			/**
			 * This method check if the action is performed (event key pressed)
			 * @param e is event
			 */
			public void actionPerformed(ActionEvent e) {
				main.setDividerLocation(510);
			}
		}

		private class SaveTraceAction extends AbstractAction {

			/**
			 * This method starts the LoaderGenerator application
			 */
			public SaveTraceAction() {

				putValue(
					SMALL_ICON,
					new ImageIcon(
						getClass().getClassLoader().getResource(
							"org/webdocwf/util/loader/" + "wizard/images/Save16.gif")));
				putValue(SHORT_DESCRIPTION, "Save Trace");
				putValue(LONG_DESCRIPTION, "Save Trace to file");
				putValue(
					ACCELERATOR_KEY,
					KeyStroke.getKeyStroke(
						'S',
						Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
				putValue(MNEMONIC_KEY, new Integer('S'));
			}

			/**
			 * This method check if the action is performed (event key pressed)
			 * @param e is event
			 */
			public void actionPerformed(ActionEvent e) {
				JFileChooser fc = new JFileChooser();
				fc.setDialogTitle("Save Octopus log ...");
				int returnVal = fc.showSaveDialog(null);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
					File file = fc.getSelectedFile();
					String text = traceArea.getText();
					try {
						Writer out = new BufferedWriter(new FileWriter(file));
						out.write(text);
						out.close();
					} catch (Exception ex) {
						ex.printStackTrace();
					}

				} else {
					//do nothing
				}
			}
		}

		private class ClearTraceAction extends AbstractAction {

			/**
			 * This method starts the LoaderGenerator application
			 */
			public ClearTraceAction() {

				putValue(
					SMALL_ICON,
					new ImageIcon(
						getClass().getClassLoader().getResource(
							"org/webdocwf/util/loader/" + "wizard/images/Delete16.gif")));
				putValue(SHORT_DESCRIPTION, "Clear Trace");
				putValue(LONG_DESCRIPTION, "Clear Trace");
				putValue(
					ACCELERATOR_KEY,
					KeyStroke.getKeyStroke(
						'L',
						Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
				putValue(MNEMONIC_KEY, new Integer('L'));
			}

			/**
			 * This method check if the action is performed (event key pressed)
			 * @param e is event
			 */
			public void actionPerformed(ActionEvent e) {
				traceArea.setText("");
			}
		}

		private class BrowseAction_GO extends AbstractAction {

			/**
			 * This method stop the LoaderGenerator application
			 */
			public BrowseAction_GO() {
				putValue(
					SMALL_ICON,
					new ImageIcon(
						getClass().getClassLoader().getResource(
							"org/webdocwf/util/loader/" + "wizard/images/Open16.gif")));
				putValue(SHORT_DESCRIPTION, "Browse for Generator output directory");
				putValue(LONG_DESCRIPTION, "Browse for Generator output directory");
				putValue(MNEMONIC_KEY, new Integer('B'));
			}

			/**
			 * This method check if the action is performed (event key pressed)
			 * @param e is event
			 */
			public void actionPerformed(ActionEvent e) {
				JFileChooser chooser = null;
				File choice = null;
				File current = new File(System.getProperty("user.dir"));
				chooser = new JFileChooser(current);
				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				chooser.setFileFilter((javax.swing.filechooser.FileFilter) new DirectoryFilter());
				chooser.setDialogTitle("Select Generator Output Directory");
				chooser.setApproveButtonText("Open");
				String strFieldText = "";

				chooser.setCurrentDirectory(new File(strFieldText));
				int v = chooser.showOpenDialog(null);
				//      desktop.requestFocus();

				switch (v) {
					case JFileChooser.APPROVE_OPTION :
						if (chooser.getSelectedFile() != null) {
							if (chooser.getSelectedFile().exists()) {
								choice = chooser.getSelectedFile();
							} else {
								File parentFile = new File(chooser.getSelectedFile().getParent());
								choice = parentFile;
							}
							generatorOutput.setText(choice.getPath());
						}
						break;

					case JFileChooser.CANCEL_OPTION :
					case JFileChooser.ERROR_OPTION :

						}
			}
		}
		
		//log dir
		private class BrowseAction_L
			extends AbstractAction {

		 
		  public BrowseAction_L() {
//			  putValue(NAME, "browse");
			putValue(SMALL_ICON,
				new ImageIcon(getClass().getClassLoader().
				getResource("org/webdocwf/util/loader/" +
				"wizard/images/Open16.gif")));
			putValue(SHORT_DESCRIPTION, "Browse for Log file directory");
			putValue(LONG_DESCRIPTION, "Browse for Log file directory");
			putValue(MNEMONIC_KEY, new Integer('B'));
		  }

		  /**
		   * This method check if the action is performed (event key pressed)
		   * @param e is event
		   */
		  public void actionPerformed(ActionEvent e) {
			JFileChooser chooser = null;
			File choice = null;
			File current = new File(System.getProperty("user.dir"));
			chooser = new JFileChooser(current);
			chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			chooser.setFileFilter((javax.swing.filechooser.FileFilter)new DirectoryFilter());
			chooser.setDialogTitle("Select Log File Directory");
			chooser.setApproveButtonText("Open");
			String strFieldText = "";

			chooser.setCurrentDirectory(new File(strFieldText));
			int v = chooser.showOpenDialog(null);
//			  parent.requestFocus();

			switch(v) {
			  case JFileChooser.APPROVE_OPTION:
				if(chooser.getSelectedFile() != null) {
				  if(chooser.getSelectedFile().exists()) {
					choice = chooser.getSelectedFile();
				  } else {
					File parentFile = new File(chooser.getSelectedFile().getParent());
					choice = parentFile;
				  }
				  setField(LOG_FILE_DIRECTORY, choice.getPath(), "label");
				}
				break;

			  case JFileChooser.CANCEL_OPTION:
			  case JFileChooser.ERROR_OPTION:

			}
		  }
		}

		//additional paths
		private class BrowseAction_AC extends AbstractAction {

			/**
			 * This method stop the LoaderGenerator application
			 */
			public BrowseAction_AC() {
				putValue(
					SMALL_ICON,
					new ImageIcon(
						getClass().getClassLoader().getResource(
							"org/webdocwf/util/loader/" + "wizard/images/Open16.gif")));
				putValue(SHORT_DESCRIPTION, "Add .jar files");
				putValue(LONG_DESCRIPTION, "Add .jar (jdbc) files to system classpath");
				putValue(MNEMONIC_KEY, new Integer('B'));
			}

			/**
			 * This method check if the action is performed (event key pressed)
			 * @param e is event
			 */
			public void actionPerformed(ActionEvent e) {
				JFileChooser chooser = null;
				File choice = null;
				File current = new File(System.getProperty("user.dir"));
				chooser = new JFileChooser(current);
				chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
				chooser.setFileFilter((javax.swing.filechooser.FileFilter) new JarFilter());
				chooser.setDialogTitle("Select .jar file");
				chooser.setAcceptAllFileFilterUsed(false);
				String strFieldText = addPaths.getText();

				if (!strFieldText.equalsIgnoreCase(""))
					strFieldText = strFieldText + ";";

				chooser.setCurrentDirectory(new File(strFieldText));
				chooser.setApproveButtonText("Open");
				int v = chooser.showOpenDialog(null);

				//      desktop.requestFocus();
				switch (v) {
					case JFileChooser.APPROVE_OPTION :
						if (chooser.getSelectedFile() != null) {
							if (chooser.getSelectedFile().exists()) {
								choice = chooser.getSelectedFile();
							} else {
								File parentFile = new File(chooser.getSelectedFile().getParent());
								choice = parentFile;
							}
							addPaths.setText(strFieldText + choice.getPath());
						}
						break;

					case JFileChooser.CANCEL_OPTION :
					case JFileChooser.ERROR_OPTION :

						chooser.removeAll();
						chooser = null;
						current = null;

				}
			}
		}

		

		//doml file
		private class BrowseAction_DOML extends AbstractAction {

			/**
			 * This method stop the LoaderGenerator application
			 */
			public BrowseAction_DOML() {
				//      putValue(NAME, "browse");
				putValue(
					SMALL_ICON,
					new ImageIcon(
						getClass().getClassLoader().getResource(
							"org/webdocwf/util/loader/" + "wizard/images/Open16.gif")));
				putValue(SHORT_DESCRIPTION, "Browse for .doml file");
				putValue(LONG_DESCRIPTION, "Browse for .doml file");
				putValue(MNEMONIC_KEY, new Integer('B'));
			}

			/**
			 * This method check if the action is performed (event key pressed)
			 * @param e is event
			 */
			public void actionPerformed(ActionEvent e) {
				JFileChooser chooser = null;
				File choice = null;
				File current = new File(System.getProperty("user.dir"));
				chooser = new JFileChooser(current);
				chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
				chooser.setFileFilter((javax.swing.filechooser.FileFilter) new DomlFilter());
				chooser.setDialogTitle("Select .doml file");
				chooser.setAcceptAllFileFilterUsed(false);
				String strFieldText = "";

				chooser.setCurrentDirectory(new File(strFieldText));
				chooser.setApproveButtonText("Open");
				int v = chooser.showOpenDialog(null);

//				parent.requestFocus();
				switch (v) {
					case JFileChooser.APPROVE_OPTION :
						if (chooser.getSelectedFile() != null) {
							if (chooser.getSelectedFile().exists()) {
								choice = chooser.getSelectedFile();
							} else {
								File parentFile = new File(chooser.getSelectedFile().getParent());
								choice = parentFile;
							}
							setField(DOML_PATH, choice.getPath(), "label");
						}
						break;

					case JFileChooser.CANCEL_OPTION :
					case JFileChooser.ERROR_OPTION :

						chooser.removeAll();
						chooser = null;

				}
			}
		}

	}
