/*
     LoaderGenerator - tool for generated xml, sql and doml file needed for Octopus.
    Copyright (C) 2003  Together
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.webdocwf.util.loader.wizard;


/**
 * LoaderOctopusEntry class set input parameters for Octopus application
 * @author Radoslav Dutina
 * @version 1.0
 */
public class OctopusLoaderData {

  private static String[] logModes = {
      "none", "normal", "full"};
  private String logMode = "";
  private String restartIndicator = "";
  private String userId = "";
  private String variables = "";
  private String logFileDirectory = "";
  private String logFileName = "";
  private String vendorConfFile = "";
  private String onErrorContinue = "";
  private String additionalPath = "";
  private String commitCount = "";
  private String returnCode = "";
  private String pathToXmlFile = "";
  private String includeTables = "";
  private String confJarStructure = "";


  /**
     * This method set value of confJarStructure parameter
     * @param conf_jar_structure is value of parameter
     */
    public void setConfJarStructure(String conf_jar_structure){
      confJarStructure=conf_jar_structure;
    }

    /**
     * This methos read value of confJarStructure parameter
     * @return value of parameter
     */
    public String getConfJarStructure(){
      return confJarStructure;
    }


  /**
   * This method set value of includeTables parameter
   * @param include_Tables is value of parameter
   */
  public void setIncludeTables(String include_Tables) {
    this.includeTables = include_Tables;
  }

  /**
   * This method read value of includeTables parameter
   * @return value of parameter
   */
  public String getIncludeTables() {
    return this.includeTables;
  }

  /**
   * Empty constructor of LoaderOctopusEntry class
   */
  public OctopusLoaderData() {
  }

  /**
   * This mehod set value of logMode parameter
   * @param log_Mode is value of parameter
   */
  public void setLogMode(String log_Mode) {
    this.logMode = log_Mode;
  }

  /**
   * This method read value of logMod parameter
   * @return value of parameter
   */
  public static String[] getLogModes() {
    return logModes;
  }

  /**
   * This method read value of logMods parameter
   * @return value of parameter
   */
  public String getLogMode() {
    return logMode;
  }

  /**
   * This method set vaule of restartIndicator parameter
   * @param restart_Indicator is value of parameter
   */
  public void setRestartIndicator(String restart_Indicator) {
    this.restartIndicator = restart_Indicator;
  }

  /**
   * This method read value of restartIndicator parameter
   * @return value of parameter
   */
  public String getRestartIndicator() {
    return this.restartIndicator;
  }

  /**
   * This method set value of parameter
   * @param user_Id is value of parameter
   */
  public void setUserId(String user_Id) {
    this.userId = user_Id;
  }

  /**
   * This method read value of userId parameter
   * @return value of parameter
   */
  public String getUserId() {
    return this.userId;
  }

  /**
   * This method set value of variables parameter
   * @param _variables is value of parameter
   */
  public void setVariables(String _variables) {
    this.variables = _variables;
  }

  /**
   * This method read value of variables parameter
   * @return value of parameter
   */
  public String getVariables() {
    return this.variables;
  }

  /**
   * This method set value of logFileDirectory parameter
   * @param log_FileDirectory is value of parameter
   */
  public void setLogFileDir(String log_FileDirectory) {
    this.logFileDirectory = log_FileDirectory;
  }

  /**
   * This method read value of logFileDirectory parameter
   * @return value of parameter
   */
  public String getLogFileDir() {
    return this.logFileDirectory;
  }

  /**
   * This method set value of logFileName parameter
   * @param log_FileName is value of parameter
   */
  public void setLogFileName(String log_FileName) {
    this.logFileName = log_FileName;
  }

  /**
   * This method read value of logFileName parameter
   * @return value of parameter
   */
  public String getLogFileName() {
    return this.logFileName;
  }

  /**
   * This method set value of vendorConfFile parameter
   * @param vendor_conf is value of parameter
   */
  public void setVendorConf(String vendor_conf) {
    this.vendorConfFile = vendor_conf;
  }

  /**
   * This method read value of vendorConfFile parameter
   * @return value of parameter
   */
  public String getVendorConf() {
    return this.vendorConfFile;
  }

  /**
   * This method set value of onErrorContinue parameter
   * @param on_errorcontinue is value of parameter
   */
  public void setOnErrorCon(String on_errorcontinue) {
    this.onErrorContinue = on_errorcontinue;
  }

  /**
   * This method read value of onErrorContinue parameter
   * @return value of parameter
   */
  public String getOnErrorCon() {
    return this.onErrorContinue;
  }

  /**
   * This method set value of additionalPath parameter
   * @param additionl_Path is value of parameter
   */
  public void setAdditionalPaths(String additionl_Path) {
    this.additionalPath = additionl_Path;
  }

  /**
   * This method read value of additionalPath parameter
   * @return value of parameter
   */
  public String getAdditionalPaths() {
    return this.additionalPath;
  }

  /**
   * This method set value of commitCount parameter
   * @param commit_Count is value of parameter
   */
  public void setCommitCount(String commit_Count) {
    this.commitCount = commit_Count;
  }

  /**
   * This method read value of commitCount parameter
   * @return value of parameter
   */
  public String getCommitCount() {
    return this.commitCount;
  }

  /**
   * This method set value of returnCode parameter
   * @param return_Code is value of parameter
   */
  public void setReturnCode(String return_Code) {
    this.returnCode = return_Code;
  }

  /**
   * This method read value of returnCode parameter
   * @return value of parameter
   */
  public String getReturnCode() {
    return this.returnCode;
  }

  /**
   * This method set value of pathToXmlFile parameter
   * @param path_to_xml is value of parameter
   */
  public void setPathToXml(String path_to_xml) {
    this.pathToXmlFile = path_to_xml;
  }

  /**
   * This method read value of pathToXmlFile parameter
   * @return value of parameter
   */
  public String getPathToXml() {
    return this.pathToXmlFile;
  }
  
  public String toConfString() {
  	String retVal = "";
  	retVal += "\nLoader.AdditionalPaths="+this.getAdditionalPaths();
	retVal += "\nLoader.CommitCount="+this.getCommitCount();
	retVal += "\nLoader.ConfJarStructure="+this.getConfJarStructure();
	retVal += "\nLoader.IncludeTables="+this.getIncludeTables();
	retVal += "\nLoader.LogFileDir="+this.getLogFileDir();
	retVal += "\nLoader.LogFileName="+this.getLogFileName();
	retVal += "\nLoader.LogMode="+this.getLogMode();
	retVal += "\nLoader.ErrorConntinue="+this.getOnErrorCon();
	retVal += "\nLoader.PathToXml="+this.getPathToXml();
	retVal += "\nLoader.RestartIndicator="+this.getRestartIndicator();
	retVal += "\nLoader.ReturnCode="+this.getReturnCode();
	retVal += "\nLoader.UserId="+this.getUserId();
	retVal += "\nLoader.Variables="+this.getVariables();
	retVal += "\nLoader.VendorConf="+this.getVendorConf();
  	return retVal;
  }

}
