package org.webdocwf.util.loader.wizard;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;

public class OctopusLoaderPanel
    extends JPanel {

  private static final String LOG_MODE = " Log mode",
      RESTART_INDICATOR = " Restart indicator",
      USER_ID = " User Id",
      VARIABLES = " Variables",
      LOG_FILE_DIRECTORY = " Log file directory",
      LOG_FILE_NAME = " Log file name",
      VENDOR_CONF_FILE = " Specific vendor conf file",
      ON_ERRORCONTINUE = " On error continue",
      ADDITIONAL_CLASSPATH = " Aditional classpath",
      COMMIT_COUNT = " Comit count",
      RETURN_CODE = " Return code",
      PATH_TO_XML_FILE = " Path to loaderJob.olj file",
      INCLUDE_TABLES = " Include List",
      PATH_TO_CONF_JAR = " Path to conf files in jar";

  //dimensions
//  private static Dimension bigButton = new Dimension(110, 25);
//  private static Dimension smallComponent = new Dimension(150, 20);
//  private static Dimension bigComponent = new Dimension(400, 20);
//  private static Dimension veryBigComponent = new Dimension(650, 20);
//  private static Dimension veryBigPlusButton = new Dimension(630, 20);
//  private static Dimension panelComponenet = new Dimension(720, 40);

  JSplitPane main;

  Border loweredBorder = BorderFactory.createEtchedBorder(EtchedBorder.LOWERED);
  Border raisedBorder = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);
  Border bevelBorder = BorderFactory.createLoweredBevelBorder();

//  private OctopusProjectFrame parent;
  private JPanel commonPanel;
  private OctopusLoaderData initData;
  private HashMap fields;
  private JTextArea traceArea;
  private JTextField additionalPath;

  public OctopusLoaderPanel() {

//    this.parent = parent;
    fields = new HashMap();
    //generatorOptions
//    JPanel loaderOptionsUp = new JPanel();
//    JPanel loaderOptionsDown = new JPanel();

    //generator input data
    JTabbedPane octopusLoaderData = new JTabbedPane();
    commonPanel = new JPanel();
    commonPanel.setLayout(new BoxLayout(commonPanel, BoxLayout.Y_AXIS));
    octopusLoaderData.addTab("Input Parameters", commonPanel);

//    loaderOptionsUp.setLayout(new BoxLayout(loaderOptionsUp, BoxLayout.Y_AXIS));
//    loaderOptionsUp.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
//    JButton help = createOctopusButton("Help", bigButton);
//    help.setAction(new OctopusHelpAction());
//    loaderOptionsUp.add(help);

    //generatorOptionsDown panel
//    loaderOptionsDown.setLayout(new BoxLayout(loaderOptionsDown, BoxLayout.Y_AXIS));
//    loaderOptionsDown.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
//    JButton start = createOctopusButton("Start", bigButton);
//    start.setAction(new StartOctopusLoader());
//    JButton stop = createOctopusButton("Stop", bigButton);
//    stop.setAction(new StopOctopusLoader());
//	 JButton save = createOctopusButton("Save", bigButton);
//	 save.setAction(new SaveProjectAction());    
//	 loaderOptionsDown.add(Box.createRigidArea(new Dimension(0,5)));
//	 loaderOptionsDown.add(start);
//	 loaderOptionsDown.add(Box.createRigidArea(new Dimension(0,5))); 
//    loaderOptionsDown.add(stop);
//	 loaderOptionsDown.add(Box.createRigidArea(new Dimension(0,5)));
//	 loaderOptionsDown.add(save);
//	 loaderOptionsDown.add(Box.createRigidArea(new Dimension(0,15)));
//	 loaderOptionsDown.add(help);

    //generatorOptions
//    JSplitPane generatorOptions = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true,
//        loaderOptionsUp, loaderOptionsDown);
//    generatorOptions.setOneTouchExpandable(true);
//    generatorOptions.setDividerLocation(0);

    //log mode
    JLabel strLogMode = OctopusProjectFrame.createOctopusLabel(LOG_MODE, OctopusGeneratorPanel.smallComponent);
    JComboBox logMode = OctopusProjectFrame.createOctopusCombobox(LOG_MODE, OctopusGeneratorPanel.veryBigComponent);
    //restart indicator
    JLabel strRestartIndicator = OctopusProjectFrame.createOctopusLabel(RESTART_INDICATOR, OctopusGeneratorPanel.smallComponent);
    JTextField restartIndicator = OctopusProjectFrame.createOctopusTextField(RESTART_INDICATOR, OctopusGeneratorPanel.veryBigComponent);
    //user id
    JLabel strUserId = OctopusProjectFrame.createOctopusLabel(USER_ID, OctopusGeneratorPanel.smallComponent);
    JTextField userId = OctopusProjectFrame.createOctopusTextField(USER_ID, OctopusGeneratorPanel.veryBigComponent);
    //variables
    JLabel strVariables = OctopusProjectFrame.createOctopusLabel(VARIABLES, OctopusGeneratorPanel.smallComponent);
    JTextField variables = OctopusProjectFrame.createOctopusTextField(VARIABLES, OctopusGeneratorPanel.veryBigComponent);
    //log file directory
    JLabel strLogFileDir = OctopusProjectFrame.createOctopusLabel(LOG_FILE_DIRECTORY, OctopusGeneratorPanel.smallComponent);
    JTextField logFileDir = OctopusProjectFrame.createOctopusTextField(LOG_FILE_DIRECTORY, OctopusGeneratorPanel.veryBigPlusButton);
    JButton logDirButton = OctopusProjectFrame.createOctopusButton("", new Dimension(20, 20));
    logDirButton.setAction(new BrowseAction_LD());
    //log file name
    JLabel strLogFileName = OctopusProjectFrame.createOctopusLabel(LOG_FILE_NAME, OctopusGeneratorPanel.smallComponent);
    JTextField logFileName = OctopusProjectFrame.createOctopusTextField(LOG_FILE_NAME, OctopusGeneratorPanel.veryBigComponent);
    //specific vendor conf file
    JLabel strSpecVendorConf = OctopusProjectFrame.createOctopusLabel(VENDOR_CONF_FILE, OctopusGeneratorPanel.smallComponent);
    JTextField specVendorConf = OctopusProjectFrame.createOctopusTextField(VENDOR_CONF_FILE, OctopusGeneratorPanel.veryBigPlusButton);
    JButton specVendorButton = OctopusProjectFrame.createOctopusButton("", new Dimension(20, 20));
    specVendorButton.setAction(new BrowseAction_XML());
    //on error continue
    JLabel strOnError = OctopusProjectFrame.createOctopusLabel(ON_ERRORCONTINUE, OctopusGeneratorPanel.smallComponent);
    JTextField onError = OctopusProjectFrame.createOctopusTextField(ON_ERRORCONTINUE, OctopusGeneratorPanel.veryBigComponent);
    //commit count
    JLabel strCommitCount = OctopusProjectFrame.createOctopusLabel(COMMIT_COUNT, OctopusGeneratorPanel.smallComponent);
    JTextField commitCount = OctopusProjectFrame.createOctopusTextField(COMMIT_COUNT, OctopusGeneratorPanel.veryBigComponent);
    //return code
    JLabel strReturnCode = OctopusProjectFrame.createOctopusLabel(RETURN_CODE, OctopusGeneratorPanel.smallComponent);
    JTextField returnCode = OctopusProjectFrame.createOctopusTextField(RETURN_CODE, OctopusGeneratorPanel.veryBigComponent);
    //pathe to olj file
    JLabel strPathToOlj = OctopusProjectFrame.createOctopusLabel(PATH_TO_XML_FILE, OctopusGeneratorPanel.smallComponent);
    JTextField pathToOlj = OctopusProjectFrame.createOctopusTextField(PATH_TO_XML_FILE, OctopusGeneratorPanel.veryBigPlusButton);
    JButton pathToOljButton = OctopusProjectFrame.createOctopusButton("", new Dimension(20, 20));
    pathToOljButton.setAction(new BrowseAction_OLJ());
    //include list
    JLabel strIncludeList = OctopusProjectFrame.createOctopusLabel(INCLUDE_TABLES, OctopusGeneratorPanel.smallComponent);
    JTextField includeList = OctopusProjectFrame.createOctopusTextField(INCLUDE_TABLES, OctopusGeneratorPanel.veryBigComponent);
    //path to conf files in jar file
    JLabel strPathToConf = OctopusProjectFrame.createOctopusLabel(PATH_TO_CONF_JAR, OctopusGeneratorPanel.smallComponent);
    JTextField pathToConf = OctopusProjectFrame.createOctopusTextField(PATH_TO_CONF_JAR, OctopusGeneratorPanel.veryBigComponent);
    //additional classpaths
	 JLabel strAdditionalPath = OctopusProjectFrame.createOctopusLabel(ADDITIONAL_CLASSPATH, OctopusGeneratorPanel.smallComponent);
	 additionalPath = OctopusProjectFrame.createOctopusTextField(ADDITIONAL_CLASSPATH, OctopusGeneratorPanel.veryBigPlusButton);
	 JButton additionalPathButton = OctopusProjectFrame.createOctopusButton("", new Dimension(20, 20));
	 additionalPathButton.setAction(new BrowseAction_AC());

    JPanel inputParamPanelLabel = new JPanel();
    inputParamPanelLabel.setLayout(new BoxLayout(inputParamPanelLabel, BoxLayout.Y_AXIS));
    JPanel inputParamPanelField = new JPanel();
    inputParamPanelField.setLayout(new BoxLayout(inputParamPanelField, BoxLayout.Y_AXIS));

    commonPanel.add(Box.createRigidArea(new Dimension(0, 15)));
    createRow(strLogMode, logMode, null);
    fields.put(LOG_MODE, logMode);
    createRow(strRestartIndicator, restartIndicator, null);
    fields.put(RESTART_INDICATOR, restartIndicator);
    createRow(strUserId, userId, null);
    fields.put(USER_ID, userId);
    createRow(strVariables, variables, null);
    fields.put(VARIABLES, variables);
    createRow(strLogFileDir, logFileDir, logDirButton);
    fields.put(LOG_FILE_DIRECTORY, logFileDir);
    createRow(strLogFileName, logFileName, null);
    fields.put(LOG_FILE_NAME, logFileName);
    createRow(strSpecVendorConf, specVendorConf, specVendorButton);
    fields.put(VENDOR_CONF_FILE, specVendorConf);
    createRow(strOnError, onError, null);
    fields.put(ON_ERRORCONTINUE, onError);
    createRow(strCommitCount, commitCount, null);
    fields.put(COMMIT_COUNT, commitCount);
    createRow(strReturnCode, returnCode, null);
    fields.put(RETURN_CODE, returnCode);
    createRow(strPathToOlj, pathToOlj, pathToOljButton);
    fields.put(PATH_TO_XML_FILE, pathToOlj);
    createRow(strIncludeList, includeList, null);
    fields.put(INCLUDE_TABLES, includeList);
    createRow(strPathToConf, pathToConf, null);
    fields.put(PATH_TO_CONF_JAR, pathToConf);
	 createRow(strAdditionalPath, additionalPath, additionalPathButton);
	 fields.put(ADDITIONAL_CLASSPATH, additionalPath);

//    JSplitPane generatorInputData = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true,
//        generatorOptions, octopusLoaderData);
//	JSplitPane generatorInputData = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true,
//			new JPanel(), octopusLoaderData);

    // output panel
    JPanel textAreaPanel = new JPanel();
    textAreaPanel.setLayout(new BoxLayout(textAreaPanel, BoxLayout.X_AXIS));
    JPanel areaOptionPanel = new JPanel();
    areaOptionPanel.setLayout(new BoxLayout(areaOptionPanel, BoxLayout.Y_AXIS));
    traceArea = new JTextArea(18, 130);
    traceArea.setLineWrap(true);
    traceArea.setEditable(false);
    traceArea.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
    JScrollPane scrollPane = new JScrollPane(traceArea,
        ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
        ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

    scrollPane.setBorder(setTitleOfBorder("Log Octopus Loader output ... ", loweredBorder));
    JButton fullScreen = OctopusProjectFrame.createOctopusButton("Full Screen", new Dimension(25, 25));
    fullScreen.setAction(new FullScreenAction());
    JButton normalScreen = OctopusProjectFrame.createOctopusButton("Normal Screen", new Dimension(25, 25));
    normalScreen.setAction(new NormalScreenAction());
    JButton saveScreen = OctopusProjectFrame.createOctopusButton("Save Trace", new Dimension(25, 25));
    saveScreen.setAction(new SaveTraceAction());
    JButton clearTrace = OctopusProjectFrame.createOctopusButton("Clear Trace", new Dimension(25, 25));
    clearTrace.setAction(new ClearTraceAction());
	 
    areaOptionPanel.add(fullScreen);
    areaOptionPanel.add(normalScreen);
    areaOptionPanel.add(saveScreen);
    areaOptionPanel.add(clearTrace);
    areaOptionPanel.add(Box.createVerticalGlue());
    areaOptionPanel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));

//    JPanel areaOptionMainPanel = new JPanel(new BorderLayout());
//    areaOptionMainPanel.add(areaOptionPanel, BorderLayout.PAGE_START);

    textAreaPanel.add(areaOptionPanel);
    textAreaPanel.add(scrollPane);
//    main = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, generatorInputData,
//        textAreaPanel);
	 main = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, octopusLoaderData,
			textAreaPanel);
    main.setOneTouchExpandable(true);
//    main.setDividerLocation(450);

//    Container container = getContentPane();
    setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
    add(main);
    setBounds(0, 0, 970, 480);
  }

  public JTextArea getTraceArea() {
  	return this.traceArea;
  }

  private void createRow(JLabel label, JComponent component, JButton button) {

    JPanel jp = new JPanel();
    jp.setLayout(new BoxLayout(jp, BoxLayout.X_AXIS));

    jp.add(label);
    jp.add(component);
    if(button != null)
      jp.add(button);
    jp.add(Box.createHorizontalGlue());

    commonPanel.add(jp);
  }

  private Border setTitleOfBorder(String title, Border border) {
    Border inb = BorderFactory.createTitledBorder(border, title);
    return inb;
  }

//  private JButton createOctopusButton(String componentName, Dimension dimension) {
//
//    JButton button = new JButton();
//    if(!componentName.equalsIgnoreCase(""))
//      button.setText(componentName);
//
//    button.setAlignmentX(Component.LEFT_ALIGNMENT);
//    button.setAlignmentY(Component.CENTER_ALIGNMENT);
//    button.setMinimumSize(new Dimension(dimension));
//    button.setMaximumSize(new Dimension(dimension));
//    button.setPreferredSize(new Dimension(dimension));
//
//    return button;
//  }
//
//  private JComboBox createOctopusCombobox(String componentName, Dimension dimension) {
//
//    JComboBox comboBox = new JComboBox();
//    comboBox.setName(componentName);
//    comboBox.setAlignmentX(Component.LEFT_ALIGNMENT);
//    comboBox.setAlignmentY(Component.CENTER_ALIGNMENT);
//    comboBox.setMinimumSize(new Dimension(dimension));
//    comboBox.setMaximumSize(new Dimension(dimension));
//    comboBox.setPreferredSize(new Dimension(dimension));
//
//    return comboBox;
//  }
//
//  private JLabel createOctopusLabel(String componentName, Dimension dimension) {
//
//    JLabel label = new JLabel();
//    label.setText(componentName);
//    label.setAlignmentX(Component.LEFT_ALIGNMENT);
//    label.setAlignmentY(Component.CENTER_ALIGNMENT);
//    label.setMinimumSize(new Dimension(dimension));
//    label.setMaximumSize(new Dimension(dimension));
//    label.setPreferredSize(new Dimension(dimension));
//
//    return label;
//  }
//
//  private JTextField createOctopusTextField(String componentName, Dimension dimension) {
//
//    JTextField textField = new JTextField();
//    textField.setName(componentName);
//    textField.setAlignmentX(Component.LEFT_ALIGNMENT);
//    textField.setAlignmentY(Component.CENTER_ALIGNMENT);
//    textField.setMinimumSize(new Dimension(dimension));
//    textField.setMaximumSize(new Dimension(dimension));
//    textField.setPreferredSize(new Dimension(dimension));
//
//    return textField;
//  }

  public void setOctopusLoaderInit(OctopusLoaderData initData, String xmlFile,
      String confJarStructure) {
    this.initData = initData;
    setField(LOG_MODE, initData.getLogMode(), "box");
    setField(LOG_FILE_DIRECTORY, initData.getLogFileDir(), "textfield");
    setField(LOG_FILE_NAME, initData.getLogFileName(), "textfield");
    setField(USER_ID, initData.getUserId(), "textfield");
    setField(VARIABLES, initData.getVariables(), "textfield");
    setField(RESTART_INDICATOR, initData.getRestartIndicator(), "textfield");
    setField(VENDOR_CONF_FILE, initData.getVendorConf(), "textfield");
    setField(ON_ERRORCONTINUE, initData.getOnErrorCon(), "textfield");
    setField(ADDITIONAL_CLASSPATH, initData.getAdditionalPaths(), "textfield");
    setField(COMMIT_COUNT, initData.getCommitCount(), "textfield");
    setField(RETURN_CODE, initData.getReturnCode(), "textfield");
    if(xmlFile != null)
      setField(PATH_TO_XML_FILE, xmlFile, "textfield");
    else
      setField(PATH_TO_XML_FILE, initData.getPathToXml(), "textfield");

    setField(INCLUDE_TABLES, initData.getIncludeTables(), "textfield");
    if(confJarStructure != null)
      setField(PATH_TO_CONF_JAR, confJarStructure, "textfield");
    else
      setField(PATH_TO_CONF_JAR, initData.getConfJarStructure(), "textfield");
  }

  public OctopusLoaderData getOctopusLoaderInit() throws Exception {
	 
    initData.setLogMode(getField(LOG_MODE, "box"));
    initData.setLogFileName(getField(LOG_FILE_NAME, "label"));
    initData.setLogFileDir(getField(LOG_FILE_DIRECTORY, "label"));
    initData.setRestartIndicator(getField(RESTART_INDICATOR, "label"));
    initData.setUserId(getField(USER_ID, "label"));
    initData.setVariables(getField(VARIABLES, "label"));
    initData.setVendorConf(getField(VENDOR_CONF_FILE, "label"));
    initData.setOnErrorCon(getField(ON_ERRORCONTINUE, "label"));
    initData.setAdditionalPaths(getField(ADDITIONAL_CLASSPATH, "label"));
    initData.setCommitCount(getField(COMMIT_COUNT, "label"));
    initData.setReturnCode(getField(RETURN_CODE, "label"));
    initData.setPathToXml(getField(PATH_TO_XML_FILE, "label"));
    initData.setIncludeTables(getField(INCLUDE_TABLES, "label"));
    initData.setConfJarStructure(getField(PATH_TO_CONF_JAR, "label"));

    return initData;
  }

  private void setField(String fieldName, String value, String type) {
    if(type.equalsIgnoreCase("textfield")) {
      JTextField field = (JTextField)fields.get(fieldName);
      field.setText(value);
    } else {
      JComboBox field = (JComboBox)fields.get(fieldName);
	  	boolean setted = false;
      for(int i = 0; i < OctopusLoaderData.getLogModes().length; i++) {
		  if( field.getItemCount() != OctopusLoaderData.getLogModes().length ) 
        	field.addItem(OctopusLoaderData.getLogModes()[i]);
        if( value.equalsIgnoreCase(OctopusLoaderData.getLogModes()[i]))
        	field.setSelectedIndex(i);
      }
	  	if(!setted)
				field.setSelectedIndex(1);
    }
  }

  private String getField(String fieldName, String type) {
    if(type.equalsIgnoreCase("label")) {
      JTextField field = (JTextField)fields.get(fieldName);
      return field.getText().trim();
    } else {
      JComboBox field = (JComboBox)fields.get(fieldName);
      return field.getSelectedItem().toString();
    }
  }

  private class FullScreenAction
      extends AbstractAction {

    /**
     * This method starts the LoaderGenerator application
     */
    public FullScreenAction() {

      putValue(SMALL_ICON,
          new ImageIcon(getClass().getClassLoader().getResource("org/webdocwf/util/loader/" +
          "wizard/images/Host16.gif")));
      putValue(SHORT_DESCRIPTION, "Full Screen");
      putValue(LONG_DESCRIPTION, "Set Trace to Full Screen");
      putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke('F',
          Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
      putValue(MNEMONIC_KEY, new Integer('F'));
    }

    /**
     * This method check if the action is performed (event key pressed)
     * @param e is event
     */
    public void actionPerformed(ActionEvent e) {
      main.setDividerLocation(0);
    }
  }

  private class NormalScreenAction
      extends AbstractAction {

    /**
     * This method starts the LoaderGenerator application
     */
    public NormalScreenAction() {

      putValue(SMALL_ICON,
          new ImageIcon(getClass().getClassLoader().getResource("org/webdocwf/util/loader/" +
          "wizard/images/Unhost16.gif")));
      putValue(SHORT_DESCRIPTION, "Normal Screen");
      putValue(LONG_DESCRIPTION, "Back to normal screen");
      putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke('N',
          Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
      putValue(MNEMONIC_KEY, new Integer('N'));
    }

    /**
     * This method check if the action is performed (event key pressed)
     * @param e is event
     */
    public void actionPerformed(ActionEvent e) {
      main.setDividerLocation(330);
    }
  }

  private class SaveTraceAction
      extends AbstractAction {

    /**
     * This method starts the LoaderGenerator application
     */
    public SaveTraceAction() {

      putValue(SMALL_ICON,
          new ImageIcon(getClass().getClassLoader().getResource("org/webdocwf/util/loader/" +
          "wizard/images/Save16.gif")));
      putValue(SHORT_DESCRIPTION, "Save Trace");
      putValue(LONG_DESCRIPTION, "Save Trace to file");
      putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke('S',
          Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
      putValue(MNEMONIC_KEY, new Integer('S'));
    }

    /**
     * This method check if the action is performed (event key pressed)
     * @param e is event
     */
    public void actionPerformed(ActionEvent e) {
      JFileChooser fc = new JFileChooser();
      fc.setDialogTitle("Save Octopus log ...");
      int returnVal = fc.showSaveDialog(null);
      if(returnVal == JFileChooser.APPROVE_OPTION) {
        File file = fc.getSelectedFile();
        String text = traceArea.getText();
        try {
          Writer out = new BufferedWriter(new FileWriter(file));
          out.write(text);
          out.close();
        }
        catch(Exception ex) {
          ex.printStackTrace();
        }

      } else {
      //do nothing
      }
    }
  }

  private class ClearTraceAction
      extends AbstractAction {

    /**
     * This method starts the LoaderGenerator application
     */
    public ClearTraceAction() {

      putValue(SMALL_ICON,
          new ImageIcon(getClass().getClassLoader().getResource("org/webdocwf/util/loader/" +
          "wizard/images/Delete16.gif")));
      putValue(SHORT_DESCRIPTION, "Clear Trace");
      putValue(LONG_DESCRIPTION, "Clear Trace");
      putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke('L',
          Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
      putValue(MNEMONIC_KEY, new Integer('L'));
    }

    /**
     * This method check if the action is performed (event key pressed)
     * @param e is event
     */
    public void actionPerformed(ActionEvent e) {
      traceArea.setText("");
    }
  }

  //additional paths
  private class BrowseAction_AC
      extends AbstractAction {

    /**
     * This method stop the LoaderGenerator application
     */
    public BrowseAction_AC() {
      putValue(SMALL_ICON,
          new ImageIcon(getClass().getClassLoader().
          getResource("org/webdocwf/util/loader/" +
          "wizard/images/Open16.gif")));
      putValue(SHORT_DESCRIPTION, "Add .jar files");
      putValue(LONG_DESCRIPTION, "Add .jar (jdbc) files to system classpath");
      putValue(MNEMONIC_KEY, new Integer('B'));
    }

    /**
     * This method check if the action is performed (event key pressed)
     * @param e is event
     */
    public void actionPerformed(ActionEvent e) {
      JFileChooser chooser = null;
      File choice = null;
      File current = new File(System.getProperty("user.dir"));
      chooser = new JFileChooser(current);
      chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
      chooser.setFileFilter((javax.swing.filechooser.FileFilter)new JarFilter());
      chooser.setDialogTitle("Select .jar file");
      chooser.setAcceptAllFileFilterUsed(false);
      String strFieldText = additionalPath.getText();
//
      if(!strFieldText.equalsIgnoreCase(""))
        strFieldText = strFieldText + ";";

      chooser.setCurrentDirectory(new File(strFieldText));
      chooser.setApproveButtonText("Open");
      int v = chooser.showOpenDialog(null);

      switch(v) {
        case JFileChooser.APPROVE_OPTION:
          if(chooser.getSelectedFile() != null) {
            if(chooser.getSelectedFile().exists()) {
              choice = chooser.getSelectedFile();
            } else {
              File parentFile = new File(chooser.getSelectedFile().getParent());
              choice = parentFile;
            }
            additionalPath.setText(strFieldText + choice.getPath());
          }
          break;

        case JFileChooser.CANCEL_OPTION:
        case JFileChooser.ERROR_OPTION:

          chooser.removeAll();
          chooser = null;
          current = null;

      }
    }
  }



  private class OctopusHelpAction
      extends AbstractAction {

    /**
     * Action which creates new help frame
     */
    public OctopusHelpAction() {
      putValue(NAME, "Help");
      putValue(SMALL_ICON,
          new ImageIcon(getClass().getClassLoader().getResource("org/webdocwf/util/loader/" +
          "wizard/images/Help16.gif")));
      putValue(SHORT_DESCRIPTION, "Help for running the program");
      putValue(LONG_DESCRIPTION, "Help for running the program");
      putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke('H',
          Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
      putValue(MNEMONIC_KEY, new Integer('H'));
    }

    /**
     * Creating event for new windows help frame
     * @param e is creating events
     */
    public void actionPerformed(ActionEvent e) {
      try {
        OctopusGeneratorHelpFrame helpFrame = new OctopusGeneratorHelpFrame();
        helpFrame.setIconImage(new ImageIcon(getClass().getClassLoader().getResource(
            "org/webdocwf/util/loader/" +
            "wizard/images/Enhydra16.gif")).getImage());
        helpFrame.setVisible(true);
      }
      catch(Exception ex) {
			String message = "Error while creating action for OctopusHelp button. Message : "+ex.getMessage();
			JOptionPane.showMessageDialog(null, message + "\n", "Error", 0);
			System.exit(0);
      }
    }
  }


  //log dir
  private class BrowseAction_LD
      extends AbstractAction {

    /**
     * This method stop the LoaderGenerator application
     */
    public BrowseAction_LD() {
//      putValue(NAME, "browse");
      putValue(SMALL_ICON,
          new ImageIcon(getClass().getClassLoader().
          getResource("org/webdocwf/util/loader/" +
          "wizard/images/Open16.gif")));
      putValue(SHORT_DESCRIPTION, "Browse for Log file directory");
      putValue(LONG_DESCRIPTION, "Browse for Log file directory");
      putValue(MNEMONIC_KEY, new Integer('B'));
    }

    /**
     * This method check if the action is performed (event key pressed)
     * @param e is event
     */
    public void actionPerformed(ActionEvent e) {
      JFileChooser chooser = null;
      File choice = null;
      File current = new File(System.getProperty("user.dir"));
      chooser = new JFileChooser(current);
      chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
      chooser.setFileFilter((javax.swing.filechooser.FileFilter)new DirectoryFilter());
      chooser.setDialogTitle("Select Log File Directory");
      chooser.setApproveButtonText("Open");
      String strFieldText = "";

      chooser.setCurrentDirectory(new File(strFieldText));
      int v = chooser.showOpenDialog(null);
//      parent.requestFocus();

      switch(v) {
        case JFileChooser.APPROVE_OPTION:
          if(chooser.getSelectedFile() != null) {
            if(chooser.getSelectedFile().exists()) {
              choice = chooser.getSelectedFile();
            } else {
              File parentFile = new File(chooser.getSelectedFile().getParent());
              choice = parentFile;
            }
            setField(LOG_FILE_DIRECTORY, choice.getPath(), "textfield");
          }
          break;

        case JFileChooser.CANCEL_OPTION:
        case JFileChooser.ERROR_OPTION:

      }
    }
  }

  private class BrowseAction_XML
      extends AbstractAction {

    /**
     * This method stop the LoaderGenerator application
     */
    public BrowseAction_XML() {
//      putValue(NAME, "browse");
      putValue(SMALL_ICON,
          new ImageIcon(getClass().getClassLoader().
          getResource("org/webdocwf/util/loader/" +
          "wizard/images/Open16.gif")));
      putValue(SHORT_DESCRIPTION, "Browse for .xml file");
      putValue(LONG_DESCRIPTION, "Browse for .xml file");
      putValue(MNEMONIC_KEY, new Integer('B'));
    }

    /**
     * This method check if the action is performed (event key pressed)
     * @param e is event
     */
    public void actionPerformed(ActionEvent e) {
      JFileChooser chooser = null;
      File choice = null;
      File current = new File(System.getProperty("user.dir"));
      chooser = new JFileChooser(current);
      chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
      chooser.setFileFilter((javax.swing.filechooser.FileFilter)new XmlFilter());
      chooser.setDialogTitle("Select .xml file");
      chooser.setAcceptAllFileFilterUsed(false);
      String strFieldText = "";

      chooser.setCurrentDirectory(new File(strFieldText));
      chooser.setApproveButtonText("Open");
      int v = chooser.showOpenDialog(null);

//      parent.requestFocus();
      switch(v) {
        case JFileChooser.APPROVE_OPTION:
          if(chooser.getSelectedFile() != null) {
            if(chooser.getSelectedFile().exists()) {
              choice = chooser.getSelectedFile();
            } else {
              File parentFile = new File(chooser.getSelectedFile().getParent());
              choice = parentFile;
            }
            setField(VENDOR_CONF_FILE, choice.getPath(), "textfield");
          }
          break;

        case JFileChooser.CANCEL_OPTION:
        case JFileChooser.ERROR_OPTION:

          chooser.removeAll();
          chooser = null;
          current = null;
      }
    }
  }

  private class BrowseAction_OLJ
      extends AbstractAction {

    /**
     * This method stop the LoaderGenerator application
     */
    public BrowseAction_OLJ() {
//      putValue(NAME, "browse");
      putValue(SMALL_ICON,
          new ImageIcon(getClass().getClassLoader().
          getResource("org/webdocwf/util/loader/" +
          "wizard/images/Open16.gif")));
      putValue(SHORT_DESCRIPTION, "Browse for LoaderJob.olj file");
      putValue(LONG_DESCRIPTION, "Browse for LoaderJob.olj file");
      putValue(MNEMONIC_KEY, new Integer('B'));
    }

    /**
     * This method check if the action is performed (event key pressed)
     * @param e is event
     */
    public void actionPerformed(ActionEvent e) {
      JFileChooser chooser = null;
      File choice = null;
      File current = new File(System.getProperty("user.dir"));
      chooser = new JFileChooser(current);
      chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
      chooser.setFileFilter((javax.swing.filechooser.FileFilter)new OctopusFileFilter());
      chooser.setDialogTitle("Select .olj file");
      chooser.setAcceptAllFileFilterUsed(false);
      String strFieldText = "";

      chooser.setCurrentDirectory(new File(strFieldText));
      chooser.setApproveButtonText("Open");
      int v = chooser.showOpenDialog(null);

//      parent.requestFocus();
      switch(v) {
        case JFileChooser.APPROVE_OPTION:
          if(chooser.getSelectedFile() != null) {
            if(chooser.getSelectedFile().exists()) {
              choice = chooser.getSelectedFile();
            } else {
              File parentFile = new File(chooser.getSelectedFile().getParent());
              choice = parentFile;
            }
            setField(PATH_TO_XML_FILE, choice.getPath(), "textfield");
          }
          break;

        case JFileChooser.CANCEL_OPTION:
        case JFileChooser.ERROR_OPTION:

          chooser.removeAll();
          chooser = null;
          current = null;

      }
    }
  }

}