/*
 * StartOctopusGeneratorAction.java. Created on Apr 23, 2004.
 */
package org.webdocwf.util.loader.wizard;

import java.awt.Toolkit;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.KeyStroke;

/**
 * 
 * 
 * @author Zoran Milakovic
 */
public class StartOctopusGeneratorAction extends AbstractAction {

	OctopusProjectFrame octopusProjectFrame;
	/**
	 * This method starts the LoaderGenerator application
	 */
	public StartOctopusGeneratorAction(OctopusProjectFrame  octopusProjectFrame, String label) {
		this.octopusProjectFrame = octopusProjectFrame;
		putValue(NAME, label);
		putValue(
			SMALL_ICON,
			new ImageIcon(
				getClass().getClassLoader().getResource(
//					"org/webdocwf/util/loader/" + "wizard/images/Play16.gif")));
					"org/webdocwf/util/loader/" + "wizard/images/StartGenerator.gif")));
		putValue(SHORT_DESCRIPTION, "Start the OctopusGenerator application");
		putValue(LONG_DESCRIPTION, "Start the OctopusGenerator application");
		putValue(
			ACCELERATOR_KEY,
			KeyStroke.getKeyStroke('G', Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
		putValue(MNEMONIC_KEY, new Integer('G'));
	}

	/**
	 * This method check if the action is performed (event key pressed)
	 * @param e is event
	 */
	public void actionPerformed(ActionEvent e) {
		OctopusGeneratorData initData = null;
		String errorMsg = null;
		try {
			octopusProjectFrame.setActiveTab(0);
			initData = octopusProjectFrame.getGeneratorPanel().getOctopusGeneratorInit();
			octopusProjectFrame.getGeneratorPanel().getTraceArea().setText("");
			OctopusGeneratorThread runGenerator =
				new OctopusGeneratorThread(
					initData, 
					errorMsg, 
					octopusProjectFrame.getGeneratorPanel().getTraceArea());
			runGenerator.start();
		} catch (Exception ex) {
			errorMsg = ex.getMessage();
		}
	}

}
