/*
 * StartOctopusLoaderAction.java. Created on Apr 23, 2004.
 */
package org.webdocwf.util.loader.wizard;

import java.awt.Toolkit;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.KeyStroke;

/**
 * 
 * 
 * @author Zoran Milakovic
 */
public class StartOctopusLoaderAction extends AbstractAction {

	OctopusProjectFrame octopusProjectFrame;

	/**
	 * This method starts the LoaderGenerator application
	 */
	public StartOctopusLoaderAction(OctopusProjectFrame octopusProjectFrame, String label) {
		
		this.octopusProjectFrame = octopusProjectFrame;
		putValue(NAME, label);
		putValue(
			SMALL_ICON,
			new ImageIcon(
				getClass().getClassLoader().getResource(
//					"org/webdocwf/util/loader/" + "wizard/images/Play16.gif")));
					"org/webdocwf/util/loader/" + "wizard/images/StartLoader.gif")));
		putValue(SHORT_DESCRIPTION, "Start the OctopusLoader application");
		putValue(LONG_DESCRIPTION, "Start the OctopusLoader application");
		putValue(
			ACCELERATOR_KEY,
			KeyStroke.getKeyStroke('L', Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
		putValue(MNEMONIC_KEY, new Integer('L'));
	}

	/**
	 * This method check if the action is performed (event key pressed)
	 * @param e is event
	 */
	public void actionPerformed(ActionEvent e) {
		OctopusLoaderData initData = null;
		String errorMsg = null;
		try {
			octopusProjectFrame.setActiveTab(1);
			initData = octopusProjectFrame.getLoaderPanel().getOctopusLoaderInit();
		} catch (Exception ex) {
			ex.printStackTrace();
			errorMsg = ex.getMessage();
		}
		octopusProjectFrame.getLoaderPanel().getTraceArea().setText("");
		OctopusLoaderThread runOctopus = new OctopusLoaderThread(
			initData, 
			errorMsg, 
			octopusProjectFrame.getLoaderPanel().getTraceArea());
		runOctopus.start();
	}

}
