/*
  Loader - tool for transfering data from one JDBC source to another and
  doing transformations during copy.
    Copyright (C) 2002  Together
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 /*
  * CreateDatabaseOperation.java   Aug 30, 2002
  * Author : Sinisa Milosevic  sinisami@eunet.yu
  *
  */


package org.webdocwf.util.loader.test;

import java.sql.Connection;
import java.sql.Statement;
import org.webdocwf.util.loader.test.DatabaseOperation;
import org.webdocwf.util.loader.Loader;
import org.webdocwf.util.loader.LoaderException;

import java.sql.SQLException;

/**
 * Inserts data in tables using Loader.
 *
 * @author Sinisa Milosevic
 * @version $Revision: 1.2 $
 */
public class LoaderOperation extends DatabaseOperation {

  private Loader loadJob = null;

  public LoaderOperation() {
  }

  public LoaderOperation(Loader load) {
    loadJob = load;
  }

  public void setLoader(Loader load) {
    loadJob = load;
  }

  ////////////////////////////////////////////////////////////////////////////
  // DatabaseOperation class

  /**
   * Executes this operation on the specified database using the specified
   * connection to the database.
   *
   * @param conn the database connection.
   */

  public void execute(Connection conn) throws SQLException {
  }

  /**
   * Executes this operation on the specified database using the Loader.
   *
   */

  public void execute() throws LoaderException {

    loadJob.load();

  }

  /**
   * Returns type of database operation
   *
   */
  public String getDatabaseOperationType() {
    return DatabaseOperation.LOADER;
  }

}
